<?php
/**
 * ܺɽ
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGame.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameEntrant.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameBatter.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGamePitcher.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbScoreMark.class.php";

class BBSB_ViewGamedetailAction extends BBSB_AbstractEditAction
{
	/**
	 * ǡ(1ʬ)
	 * @var unknown_type
	 */
	var $mGameList				= null;

	/**
	 * 蹶।˥󥰥
	 * @var unknown_type
	 */
	var $mFirstTeamScoreList	= array();

	/**
	 * 蹶।˥󥰥
	 * @var unknown_type
	 */
	var $mLastTeamScoreList		= array();

	/**
	 * Ƿѥ˥(PC)
	 * @var unknown_type
	 */
	var $mBatInningList			= array();

	/**
	 * Ƿӥǡ(PCMobile)
	 * @var unknown_type
	 */
	var $mBatScoreList			= array();

	/**
	 * Ƿ ĹǼԥǡ(PC)
	 * @var unknown_type
	 */
	var $mLongHitsDat			= array();

	/**
	 * Ƿӥǡ(Mobile)
	 * ˥Ƿ
	 * @var unknown_type
	 */
	var $mBatInScoreList		= array();

	/**
	 * ӥǡ
	 * @var unknown_type
	 */
	var $mPitchScoreList		= array();

	/**
	 * å
	 * @var unknown_type
	 */
	var $mDelMsg				= null;

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{

		// gidɬ
		if( !xoops_getrequest('gid') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$gid = xoops_getrequest('gid');

		// delϺ⡼()
		if( xoops_getrequest('del') ){
			$adminmode = null;
			if( is_object($controller->mRoot->mContext->mXoopsUser) ){
				$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
			}
			if( !$adminmode ){
				$controller->executeForward(XOOPS_URL . '/');
			}
			$this->mDelMsg = _MD_BBSB_INFO_DELCONFIRM;
		}

		// ǡDB󥹥
		$dbGame = new BBSB_DbGame();
		// ǡ
		$wherestr = " WHERE GameID='" . $gid . "' ";
		$this->mGameList = $dbGame->getGameShowInfo( $wherestr,	_BBSB_LIMIT_1 );
		if( !$this->mGameList ){
			$controller->executeForward(XOOPS_URL . '/');	// 쥳ɤʤäۡJump
		}
		if( mb_strlen($this->mGameList[0]['FirstTeamName']) > 20 ){
			$this->mGameList[0]['FirstTeamName']	= mb_substr( $this->mGameList[0]['FirstTeamName'], 0, 20) . "...";
		}
		if( mb_strlen($this->mGameList[0]['LastTeamName']) > 20 ){
			$this->mGameList[0]['LastTeamName']		= mb_substr( $this->mGameList[0]['LastTeamName'], 0, 20) . "...";
		}
		// ˥󥰥ǡκͼ
		// ϤƤ륤˥󥰤ϺǸޤɽ롣(PCΤȤΤߡMobileMax12˥󥰤Ȥ)
		$ingmax = _BBSB_OP_GAME_DISPINNINGS;
		if( $this->mMobile ){
			if( $ingmax > 12 ){	$ingmax = 12;}
			$this->mGameList[0]['DispInnings'] = $ingmax;
		} else {
			$this->mGameList[0]['DispInnings'] = $ingmax;
			if( $this->mGameList[0]['Itop'][$ingmax] !== null){
				for( $icnt = _BBSB_OP_GAME_DISPINNINGS ; $icnt < 25 ; $icnt++ ){
					if( $this->mGameList[0]['Itop'][$icnt] !== null ){
						$ingmax = $icnt;
						continue;
					}
				}
				$this->mGameList[0]['DispInnings'] = $ingmax;	// ǽ˥󥰤
			}
		}
		for( $icnt = $this->mGameList[0]['DispInnings'] ; $icnt < 25 ; $icnt++ ){	// ǽ˥󥰰ʹߤunset
			unset($this->mGameList[0]['Itop'][$icnt]);
			unset($this->mGameList[0]['Ibottom'][$icnt]);
		}

		// GameIDɳդüԥǡ
		$dbGe = new BBSB_DbGameEntrant();
		$sqlstr =	" SELECT E.UserID,E.PlayOrder,E.ChangeCnt,E.Position1,E.Position2,E.StolenBaseSuc,";
		$sqlstr .=	"E.StolenBaseFail,E.RunsCnt,E.ErrorsCnt,E.WinningRun, ";
		$sqlstr .=	"M.FullName,M.NickName,M.UniformNo ";
		$sqlstr .=  " FROM " . $dbGe->mDb->prefix('bb_gameentrant') . " E, ";
		$sqlstr .= 	$dbGe->mDb->prefix('bb_member') . " M ";
		$sqlstr .=	" WHERE E.GameID='" . $gid . "'";
		$sqlstr .=	"   AND E.UserID=M.UserID ";
		$sqlstr .=	" ORDER BY E.PlayOrder,E.ChangeCnt";
		$this->mBatScoreList = $dbGe->getList( $sqlstr );

		// Ƿ⥹ȥ˥ͤ
		if( $this->mMobile ){
			$this->getBatterScoreM( $gid, $this->mBatInScoreList, true );	// Mobile
		} else {
			$this->getBatterScore( $gid, $this->mBatInningList, $this->mBatScoreList, true );
		}

		// ޡIDʸɽѴ'ScoreMark'˥åȤ
		$dbSML	= new BBSB_DbScoreMark();
		$list	= $dbSML->getAllList();
		// ޡʸѴ
		$MarkList = array();
		foreach( $list as $key => $dat ){
			$MarkList[$dat['ScoreMarkID']] = $dat['ScoreMarkName'];
		}
		// ǽȯ/ʸ
		$startingList = array(	_MD_BBSB_LANG_CHANGECNT,			// ȯ
								_MD_BBSB_LANG_CHANGECNTCHG . "1",	// 1
								_MD_BBSB_LANG_CHANGECNTCHG . "2",	// 2
								_MD_BBSB_LANG_CHANGECNTCHG . "3",
								_MD_BBSB_LANG_CHANGECNTCHG . "4",
								_MD_BBSB_LANG_CHANGECNTCHG . "5",
								_MD_BBSB_LANG_CHANGECNTCHG . "6",
								_MD_BBSB_LANG_CHANGECNTCHG . "7",
								_MD_BBSB_LANG_CHANGECNTCHG . "8");
		$hitsary = array( "H","2H","3H","HR","BH" );

		if( $this->mMobile ){
			// ɽѤ˥ǡ(Mobile)
			foreach( $this->mBatScoreList as $rkey => &$rdat ){	// üԥ롼
				// ȯ/塧ͤʸѴ
				$chg = $rdat['ChangeCnt'];
				$rdat['ChangeCnt']		= $startingList[$chg];

				// ̾ɽ˥å͡ɽȽꤷNameɽѤ̾ꤹ롣
				$this->setDispName( $rdat );

				// Ѵ
				$rdat['Position1'] = $this->getPositionStr( $rdat['Position1'] );
				$rdat['Position2'] = $this->getPositionStr( $rdat['Position2'] );

				// 
				if( $rdat['WinningRun'] ){ $rdat['WinningRun'] = '*'; }
			}
			foreach( $this->mBatInScoreList as $ikey => &$idat ){	// ˥襹롼
				// ̾ɽ˥å͡ɽȽꤷNameɽѤ̾ꤹ롣
				$this->setDispName( $idat );

				// ʸѴ
				if( $idat['ScoreMarkID'] ){
					$id = $idat['ScoreMarkID'];
					$idat['ScoreMark']	= $MarkList[$id];
					$dir = $idat['Direction'];
					$idat['Direction']	= $this->getPositionStr( $dir );
					$idat['Hits'] = false;
					if( in_array( $idat['ScoreMarkID'], $hitsary ) ){
						$idat['Hits'] = true;
					}
				}
			}

		} else {
			// ɽѤ˥ǡ(PC)
			$this->mLongHitsDat['HitsCnt'] = 0;
			$this->mLongHitsDat['2H'] = $this->mLongHitsDat['3H'] = $this->mLongHitsDat['HR'] = "";
			foreach( $this->mBatScoreList as $rkey => &$rdat ){	// üԥ롼
				// ȯ/塧ͤʸѴ
				$chg = $rdat['ChangeCnt'];
				$rdat['ChangeCnt']		= $startingList[$chg];

				// ̾ɽ˥å͡ɽȽꤷNameɽѤ̾ꤹ롣
				$this->setDispName( $rdat );

				// Ѵ
				$rdat['Position1'] = $this->getPositionStr( $rdat['Position1'] );
				$rdat['Position2'] = $this->getPositionStr( $rdat['Position2'] );

				// ʸѴ
				if( isset($rdat['ScoreMarkID']) ){
					foreach( $rdat['ScoreMarkID'] as $ckey => &$cdat ){
						if( $rdat['ScoreMarkID'][$ckey] ){
							$id = $rdat['ScoreMarkID'][$ckey];
							$rdat['ScoreMark'][$ckey]	= $MarkList[$id];
							$dir = $rdat['Direction'][$ckey];
							$rdat['Direction'][$ckey]	= $this->getPositionStr( $dir );
							if( $rdat['Direction'][$ckey] == "" ){$rdat['Direction'][$ckey] = _MD_BBSB_LANG_BLANK . "&nbsp;";}//쥤ѤѶ
							$rdat['Hits'][$ckey] = false;
							if( in_array( $rdat['ScoreMarkID'][$ckey], $hitsary ) ){
								$rdat['Hits'][$ckey] = true;

								$this->mLongHitsDat['HitsCnt']++;		// ǹ׿
								// ĹǼʸ
								if( $rdat['ScoreMarkID'][$ckey] != "H" && $rdat['ScoreMarkID'][$ckey] != "BH" ){
									$hkind = $rdat['ScoreMarkID'][$ckey];
									if( $this->mLongHitsDat[$hkind] ){
										$this->mLongHitsDat[$hkind] .= ",&nbsp";
									}
									$this->mLongHitsDat[$hkind] .= $rdat['Name'];
								}
							}
						}
					}
				}
				// 
				if( $rdat['WinningRun'] ){ $rdat['WinningRun'] = '*'; }
			}
		}

		// gidɳդǡ
		$dbPi = new BBSB_DbGamePitcher();
		$sqlstr =	" SELECT P.UserID,P.ChangeCnt,P.Innings,P.OutCnt,";
		$sqlstr .=	"P.EarnedRuns,P.Runs,P.KCnt,P.BCnt,P.DBCnt,";
		$sqlstr .=	"P.HCnt,P.HRCnt,P.NumOfPitch,P.Win,P.Lose,P.Save,P.Hold, ";
		$sqlstr .=	"M.FullName,M.NickName,M.UniformNo ";
		$sqlstr .=  " FROM " . $dbGame->mDb->prefix('bb_gamepitcher') . " P, ";
		$sqlstr .= 	$dbGame->mDb->prefix('bb_member') . " M ";
		$sqlstr .=	" WHERE P.GameID='" . $gid . "'";
		$sqlstr .=	"   AND P.UserID=M.UserID ";
		$sqlstr .=	" ORDER BY P.ChangeCnt";
		$this->mPitchScoreList = $dbPi->getList( $sqlstr );

		// ԤȽ&̾
		foreach( $this->mPitchScoreList as $key => &$dat ){
			if( $dat['Innings']==null ){ $this->mPitchScoreList[$key]['Innings']=0; }
			if( $dat['OutCnt']==null  ){ $this->mPitchScoreList[$key]['OutCnt']=0; }
			if( $dat['Lose'] ){ $this->mPitchScoreList[$key]['pitchresult'] = _MD_BBSB_LANG_LOSE2; }// 
			if( $dat['Win']  ){ $this->mPitchScoreList[$key]['pitchresult'] = _MD_BBSB_LANG_WIN; }	// 
			if( $dat['Save'] ){ $this->mPitchScoreList[$key]['pitchresult'] = _MD_BBSB_LANG_SAVE; }	// 
			if( $dat['Hold'] ){ $this->mPitchScoreList[$key]['pitchresult'] = _MD_BBSB_LANG_HOLD; }	// ۡ

			// ̾ɽ˥å͡ɽȽꤷNameɽѤ̾ꤹ롣
			$this->setDispName( $dat );
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	/**
	 * ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// 󥻥
		if( !xoops_getrequest('delbutton') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		// delɬ
		if( !xoops_getrequest('del') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$gid = xoops_getrequest('del');

		// delϺ⡼()
		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		// ơ֥
		$dbGa = new BBSB_DbGame();
		$dbGa->setData( 'GameID',	$gid );
		$ret = $dbGa->delete('bb_game');

		// üԥơ֥
		$dbGE =& new BBSB_DbGameEntrant();
		$dbGE->unsetData();
		$dbGE->setData( 'GameID', $gid );
		$ret = $dbGE->delete( 'bb_gameentrant' );

		// Хåơ֥
		$dbGB =& new BBSB_DbGameBatter();
		$dbGB->unsetData();
		$dbGB->setData( 'GameID', $gid );
		$ret = $dbGB->delete( 'bb_gamebatter' );

		// ԥå㡼ơ֥
		$dbGP =& new BBSB_DbGamePitcher();
		$dbGP->unsetData();
		$dbGP->setData( 'GameID', $gid );
		$ret = $dbGP->delete( 'bb_gamepitcher' );

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ǡɽؿ
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewgamedetailM.html");	// Mobile
			$render->setAttribute("inscore",		$this->mBatInScoreList);
		} else {
			$render->setTemplateName("bbsb_viewgamedetail.html");
			$render->setAttribute("batinnings",		$this->mBatInningList);
			$render->setAttribute("longhitsdat",	$this->mLongHitsDat);		// ĹǼʸ
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);
		}

		// ǷӤΥ˥󥰡ǷӡӤեǡ˥å
		$render->setAttribute("game",			$this->mGameList);
		$render->setAttribute("batscores", 		$this->mBatScoreList);
		$render->setAttribute("pitchscores",	$this->mPitchScoreList);

		// Υå
		$render->setAttribute("delmsg",			$this->mDelMsg );

		// :
		// ӷ̥쥯ȥܥå
		$pitchresultList = array(	'Lose'	=>	_MD_BBSB_LANG_LOSE2,	// 
									'Win'	=>	_MD_BBSB_LANG_WIN,		// 
									'Save'	=>	_MD_BBSB_LANG_SAVE,		// 
									'Hold'	=>	_MD_BBSB_LANG_HOLD);	// ۡ
		$render->setAttribute("pitchresults", $pitchresultList );
	}

	/**
	 * ΤȤ̤
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$nendo	= xoops_getrequest('nendo');
		if( $nendo ){
			$nendo = "&nendo=" . $nendo;
		}
		$del	= xoops_getrequest('del');
		if( $del ){
			$del = "&del=" . $del;
		}
		$controller->executeForward("./index.php?action=ViewGamelist" . $nendo . $del );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν 
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$nendo	= xoops_getrequest('nendo');
		if( $nendo ){
			$nendo = "&nendo=" . $nendo;
		}
		$controller->executeForward("./index.php?action=ViewGamelist" . $nendo );
	}
}

?>
