<?php
/**
 * 
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGame.class.php";

/***
 * @internal
 * @public
 */
class BBSB_ViewGamelistAction extends BBSB_AbstractEditAction
{
	/**
	 * ǯ٥쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mNendoList			= array();

	/**
	 * ꡼/ť쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mLeagueList		= array();

	/**
	 * /ȡʥȥ쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mTournamentList	= array();

	/**
	 * 糧쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mGameOrderList		= array();

	/**
	 * 饦ɥ쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mGroundList		= array();

	/**
	 * ꥻ쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mOpponentList		= array();

	/**
	 * //ʬ ι׿
	 * @var unknown_type
	 */
	var $mResultSummary		= array();

	/**
	 * ǡ
	 * @var unknown_type
	 */
	var $mGameList			= array();

	/**
	 * ˥󥰥ǡ
	 * @var unknown_type
	 */
	var $mInningList		= array();

	/**
	 * 쥳ɺå
	 * @var unknown_type
	 */
	var $mDelMsg			= null;

	/**
	 * PageNavi
	 * @var unknown_type
	 */
	var $mPageNavi			= array();

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		$dbGame = new BBSB_DbGame();

		$this->mNendoList		= $dbGame->getSelectNendoList();		// ǯ٥ꥹȼ(쥳ɤ¸ߤǯ٤Τ߼ǯ٥ꥹȤȤ)
		$this->mLeagueList		= $dbGame->getSelectLeagueList();		// ꡼/ťꥹȼ(쥳ɤ¸ߤ꡼Τ߼ǯ٥ꥹȤȤ)
		$this->mLeagueList		= $this->truncatestr( $this->mLeagueList,		'LeagueName', 20 );
		$this->mTournamentList	= $dbGame->getSelectTournamentList();	// /ȡʥȥꥹȼ(쥳ɤ¸ߤȡʥȤΤ߼ǯ٥ꥹȤȤ)
		$this->mTournamentList	= $this->truncatestr( $this->mTournamentList,	'TournamentName', 20 );
		$this->mGameOrderList	= $dbGame->getSelectGameOrderList();	// ꥹȼ(쥳ɤ¸ߤΤ߼ǯ٥ꥹȤȤ)
		$this->mGameOrderList	= $this->truncatestr( $this->mGameOrderList,	'GameOrderName', 7 );
		$this->mGroundList		= $dbGame->getSelectGroundList();		// 饦ɥꥹȼ(쥳ɤ¸ߤ륰饦ɤΤ߼ǯ٥ꥹȤȤ)
		$this->mGroundList		= $this->truncatestr( $this->mGroundList,		'GroundName', 20 );
		$this->mOpponentList	= $dbGame->getSelectOpponentList();		// ꥹȼ(쥳ɤ¸ߤΤ߼ǯ٥ꥹȤȤ)
		$this->mOpponentList	= $this->truncatestr( $this->mOpponentList,		'TeamName', 20 );

		// WHERE
		if( !isset($_GET['nendo']) && $this->mNendoList){
			$maxidx = count($this->mNendoList)-1;
			if( isset($this->mNendoList[$maxidx]['Nendo']) ){
				if( $this->mNendoList[$maxidx]['Nendo'] ){
					$_GET['nendo']	= $this->mNendoList[$maxidx]['Nendo'];	// ǯ٤ꤵƤʤкǿǯ٤ǥ쥳ɼ롣
				}
			}
		}
		$wherestr	= $this->createWhereStrForSearch();
		$sortstr	= " ORDER BY G.EventDate DESC,GameSeq DESC";

		// ڡּ
		if( !xoops_getrequest('start') && !xoops_getrequest('perpage') ){
			// PageNaviѤλ꤬ʤ0ܤ100Լ(PCξ)
			$startrow	= 0;
			$perpage	= $this->mMobile? _BBSB_PAGENAVI_PERPAGE_M : _BBSB_PAGENAVI_PERPAGE;
		} else {
			$startrow	= intval(xoops_getrequest('start'));
			$perpage	= xoops_getrequest('perpage');
		}
		$lstr = $startrow . "," . $perpage;

		// ꥹȼ
		$this->mGameList = $dbGame->getGameShowInfo( $wherestr, $lstr, $sortstr, true );
		// ׷
		$cnum = $dbGame->getList( "SELECT FOUND_ROWS() AS CNT" );

		// pagenavi
		$ustr = _BBSB_MODULE_URL . "index.php?action=ViewGamelist";
		if( xoops_getrequest('nendo')!==null	){ $ustr .= "&nendo="			. xoops_getrequest('nendo'); }
		if( xoops_getrequest('month')			){ $ustr .= "&month="			. xoops_getrequest('month'); }
		if( xoops_getrequest('leagueid')		){ $ustr .= "&leagueid="		. xoops_getrequest('leagueid'); }
		if( xoops_getrequest('tournamentid')	){ $ustr .= "&tournamentid="	. xoops_getrequest('tournamentid'); }
		if( xoops_getrequest('gameorderid')		){ $ustr .= "&gameorderid="		. xoops_getrequest('gameorderid'); }
		if( xoops_getrequest('groundid')		){ $ustr .= "&groundid="		. xoops_getrequest('groundid'); }
		if( xoops_getrequest('opponentid')		){ $ustr .= "&opponentid="		. xoops_getrequest('opponentid'); }
		$ustr .= "&perpage=" . $perpage;
		$this->mPageNavi = $this->setPageNavi( $startrow, $perpage, $cnum[0]['CNT'], $ustr  );

		// ̾Хåƥ꡼ʸĹtruncate롣ϤƤ륤˥󥰤ϺǸޤɽ롣
		foreach( $this->mGameList as &$dat ){
			$ingmax = _BBSB_OP_GAME_DISPINNINGS;
			$dat['DispInnings'] = $ingmax;
			if( mb_strlen($dat['FirstTeamName']) > 10 ){
				$dat['FirstTeamName'] = mb_substr( $dat['FirstTeamName'], 0, 10) . "...";
			}
			if( mb_strlen($dat['LastTeamName']) > 10 ){
				$dat['LastTeamName'] = mb_substr( $dat['LastTeamName'], 0, 10) . "...";
			}
			if( mb_strlen($dat['FirstBattery']) > 17 ){
				$dat['FirstBattery'] = mb_substr( $dat['FirstBattery'], 0, 17) . "...";
			}
			if( mb_strlen($dat['LastBattery']) > 17 ){
				$dat['LastBattery'] = mb_substr( $dat['LastBattery'], 0, 17) . "...";
			}
			if( $dat['Itop'][$ingmax] !== null ){
				for( $icnt = _BBSB_OP_GAME_DISPINNINGS ; $icnt < 25 ; $icnt++ ){
					if( $dat['Itop'][$icnt] !== null ){
						$ingmax = $icnt;
						continue;
					}
				}
				$dat['DispInnings'] = $ingmax;	// ǽ˥󥰤
			}
			for( $icnt = $dat['DispInnings'] ; $icnt < 25 ; $icnt++ ){	// ǽ˥󥰰ʹߤunset
				unset($dat['Itop'][$icnt]);
				unset($dat['Ibottom'][$icnt]);
			}
			// Result ""/""/"ʬ"̤
			if( ($dat['Result'] % 10) == 0 ){
				$dat['ResultStr'] = "Lose";
			} else if( ($dat['Result'] % 10) == 1 ){
				$dat['ResultStr'] = "Win";
			} else if( $dat['Result'] % 10 == 2 ){
				$dat['ResultStr'] = "Even";
			} else {
				$dat['ResultStr'] = "";
			}
		}

		// //ʬ ׿μ
		$sqlstr =	" SELECT CASE WHEN Result IN ('0','10','20','30') THEN 'Lose'";
		$sqlstr .=	"             WHEN Result IN ('1','11','21','31') THEN 'Win'";
		$sqlstr .=	"             WHEN Result IN ('2') THEN 'Even'";
		$sqlstr .=	"        END AS ResultSummary,  count(*) AS COUNT ";
		$sqlstr .=	" FROM " . $dbGame->mDb->prefix('bb_game') . " G ";
		$sqlstr =	$sqlstr . $wherestr . " GROUP BY ResultSummary ";
		$this->mResultSummary	= $dbGame->getList( $sqlstr );

		// νͤ-1
		if( xoops_getrequest('opponentid') === null ){
			$_GET['opponentid']='-1';
		}
		return BBSB_FRAME_VIEW_INDEX;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewgamelistM.html");	// Mobile
		} else {
			$render->setTemplateName("bbsb_viewgamelist.html");
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);
		}

		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		$render->setAttribute('adminmode',		$adminmode);			// ¤Τ桼ɤ
		$render->setAttribute('delmsg',			$this->mDelMsg);		// å

		// 쥯ȥܥå
		$render->setAttribute("nendolist",		$this->mNendoList);		// ǯ٥쥯ȥܥå
		$montharray = array("1","2","3","4","5","6","7","8","9","10","11","12");
		$render->setAttribute("months",			$montharray);			// Υ쥯ȥܥå
		$render->setAttribute("leaguelist", 	$this->mLeagueList);	// ꡼
		$render->setAttribute("tournamentlist",	$this->mTournamentList);// ȡʥ
		$render->setAttribute("gameorderlist",	$this->mGameOrderList);	// 
		$render->setAttribute("groundlist",		$this->mGroundList);	// 饦
		$render->setAttribute("opponentlist",	$this->mOpponentList);	// 

		// //ʬ ׿
		$WinSum = $LoseSum = $EvenSum = 0;
		foreach( $this->mResultSummary as $key => $value ){
			if( $value['ResultSummary'] == 'Win' ){
				$WinSum = $value['COUNT'];
			} else if( $value['ResultSummary'] == 'Lose' ){
				$LoseSum = $value['COUNT'];
			} else if( $value['ResultSummary'] == 'Even' ){
				$EvenSum = $value['COUNT'];
			}
		}
		$render->setAttribute('WinSum',		$WinSum );
		$render->setAttribute('LoseSum',	$LoseSum );
		$render->setAttribute('EvenSum',	$EvenSum );

		$render->setAttribute('gameList',	$this->mGameList );			// ǡ
		$render->setAttribute('pagenavi',	$this->mPageNavi );			// ڡʥӾ

	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}
}
?>