<?php
// ԡǡܹ

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/admin/forms/AdminSwitchOverForm.class.php";	// ե९饹
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGame.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameEntrant.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameBatter.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGamePitcher.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameOrder.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGround.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbLeague.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbMember.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbOpponent.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbTournament.class.php";

class BBSB_SwitchOverAction extends BBSB_AbstractEditAction
{
	/**
	 * ʤ߾
	 * @var unknown_type
	 */
	var $mTimeStr	= "1970-00-00";

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm =& new BBSB_SwitchOverForm();
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		$this->mActionForm->mFormProperties['ikzcourse']->mValue	= 1;	// ַ󥳡פϥե꡼Ǥǥեȡ
		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * ܹԽ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		$this->mActionForm->load($this->mObject);	// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭͤ

		if( $this->mActionForm->mFormProperties['method']->mValue == "dir" ){
			// ǥ쥯ȥѥΰܹԤξ

			$wpath = $this->mActionForm->mFormProperties['websbpath']->mValue;
			if( !file_exists( $wpath ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DIRNOTFOUND . ":" . $wpath );
				return BBSB_FRAME_VIEW_INPUT;
			}

			// С (mst/member.cgi)  1:ֹ桢2:Ļ3:̾11:оݳե饰
			$mfile="$wpath/mst/member.cgi";
			if( !file_exists( $mfile ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $mfile );		// file not found
				return BBSB_FRAME_VIEW_INPUT;
			}
			$fstr = file( $mfile, FILE_IGNORE_NEW_LINES );
			if( $fstr === false ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $mfile );	// file read error
				return BBSB_FRAME_VIEW_INPUT;
			}
			$ret = $this->insMemberFromFile( $mfile, $fstr );		// ХꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// 饦 (mst/gr.cgi)  1:饦̾
			$gfile = "$wpath/mst/gr.cgi";
			if( !file_exists( $gfile ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $gfile );		// file not found
				return BBSB_FRAME_VIEW_INPUT;
			}
			$fstr = file( $gfile, FILE_IGNORE_NEW_LINES );
			if( $fstr === false ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $gfile );	// file read error
				return BBSB_FRAME_VIEW_INPUT;
			}
			$ret = $this->insGroundFromFile( $gfile, $fstr );		// 饦ɥꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// ꡼̾ (mst/syusai.cgi) 1:꡼̾
			$lfile = "$wpath/mst/syusai.cgi";
			if( !file_exists( $lfile ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $lfile );		// file not found
				return BBSB_FRAME_VIEW_INPUT;
			}
			$fstr = file( $lfile, FILE_IGNORE_NEW_LINES );
			if( $fstr === false ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $lfile );	// file read error
				return BBSB_FRAME_VIEW_INPUT;
			}
			$ret = $this->insLeagueFromFile( $lfile, $fstr );		// ꡼ꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// ȡʥ()̾ (mst/taikai.cgi) 1:ȡʥ̾
			$tfile = "$wpath/mst/taikai.cgi";
			if( !file_exists( $tfile ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $tfile );		// file not found
				return BBSB_FRAME_VIEW_INPUT;
			}
			$fstr = file( $tfile, FILE_IGNORE_NEW_LINES );
			if( $fstr === false ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $tfile );	// file read error
				return BBSB_FRAME_VIEW_INPUT;
			}
			$ret = $this->insTournamentFromFile( $tfile, $fstr );	// ȡʥȥꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// ̾ (mst/kaisen.cgi) 1:̾
			$gofile = "$wpath/mst/kaisen.cgi";
			if( !file_exists( $gofile ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $gofile );		// file not found
				return BBSB_FRAME_VIEW_INPUT;
			}
			$fstr = file( $gofile, FILE_IGNORE_NEW_LINES );
			if( $fstr === false ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $gofile );	// file read error
				return BBSB_FRAME_VIEW_INPUT;
			}
			$ret = $this->insGameOrderFromFile( $gofile, $fstr );	// ꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// Ƚ kihon.cgi(ե)ɤ߹"jiteam"˥åȤƤ뼫̾򽦤
			$kfile = "$wpath/mst/kihon.cgi";
			if( !file_exists( $kfile ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $kfile );	// file not found
				return BBSB_FRAME_VIEW_INPUT;
			}
			$hr = fopen( $kfile, "r" );
			if( $hr ){
				while( !feof($hr) ){
					$buf = fgets( $hr );
					if( substr( $buf, 0, 7 ) == "jiteam," ){
						$buf = mb_convert_encoding( $buf, _CHARSET, "SJIS" );		// ʸѴ
						$ownTeamName = trim( substr( strstr($buf,','), 1) );		// ̾
						break;
					}
				}
			} else {
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $kfile );
				return BBSB_FRAME_VIEW_INPUT;
			}
			fclose( $hr );

			// ǡ(data/seisekiyyyymmdd-n.txt
			$dirname = "$wpath/data/";
			$dirarray = scandir( $dirname );
			foreach( $dirarray as $key => $file ){	// եΥ롼
				if( strpos($file,'seiseki')===0 ){
					$gfile = $dirname . $file;
					if( !file_exists( $gfile ) ){
						$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $gfile );	// file not found
						return BBSB_FRAME_VIEW_INPUT;
					}
					$fstr = file( $gfile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES );					// Ժ&ɤФ
					if( $fstr === false ){
						$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $gfile );// file read error
						return BBSB_FRAME_VIEW_INPUT;
					}
					// ǡݡ
					$EventDate	= substr(basename($gfile),7,8);		// 糫դϥե̾
					$GameSeq	= substr(basename($gfile),16,1);		// ϥե̾
					$ret = $this->insGameFromFile( $gfile, $fstr, $EventDate, $GameSeq, $ownTeamName );
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_CONVERTERROR . ":"  . $gfile );// file read error
						return $ret;
					}
				}
			}

		} else if( $this->mActionForm->mFormProperties['method']->mValue == "ikz" ){
			// ֹԤHPΰܹԤξ
			// HTMLѡơäWeb֥åƱǡեΥեޥåȷѴ롣
			// θ塢web֥åΰܹԤƱͤˡDBϿ롣

			// ʤǯͤ¸
			$year	= $this->mActionForm->get('RefineYear');
			$month	= $this->mActionForm->get('RefineMonth');
			if( !$year  ){ $year = "1970"; }		// 1970ˤΤϺٲɽȤ˶֤ˤ뤿
			if( !$month ){ $month = "00";  }
			$ymd = $year . "-" . $month . "-00";
			$this->mTimeStr = $ymd;

			require_once XOOPS_ROOT_PATH . "/common/simple_html_dom/simple_html_dom.php";		// HTML DOM Perser
			set_time_limit(BBSB_SET_TIME_LIMIT);	// ˻֤ΤǡPHP¹Ի֤ĹȤ롣

			// ܹԸURLѥɤΥå
			$ikzurl = $this->mActionForm->mFormProperties['ikzurl']->mValue;
			if( !$ikzurl ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND . ":" . $ikzurl );		// Url or password invalid
				return BBSB_FRAME_VIEW_INPUT;
			}
			$ikzpass = $this->mActionForm->mFormProperties['ikzpass']->mValue;
			if( !$ikzurl ){
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_INJURY, $ikzpass));
				return BBSB_FRAME_VIEW_INPUT;
			}
			// 󥳡(1:ե꡼ǡ2:ɥХ󥹥ץ饹(Web֥å2))
			$course	= $this->mActionForm->get('ikzcourse');
			if( $course < 1 || 2 < $course ){
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_INJURY, $course));
				return BBSB_FRAME_VIEW_INPUT;
			}

			$tName		= basename($ikzurl);
			$uInfo		= parse_url($ikzurl);
			if( isset($uInfo['scheme']) && isset($uInfo['host']) ){
				if( $course == 1 ){ $dir = _BBSB_OP_IKZFREEDIR;
				} else {			$dir = _BBSB_OP_IKZWEBSB2; }
				$baseUrl	= $uInfo['scheme'] . "://" . $uInfo['host'] . "/" . $dir;
			} else {
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND . ":" . $ikzurl );		// Url or password invalid
				return BBSB_FRAME_VIEW_INPUT;
			}

			// 
			// ե(member.cgi)ǥǡ  1:ֹ桢2:Ļ3:̾11:оݳե饰
			$mUrl = $baseUrl . "/k_member.cgi";
			$pstr = "ikzhp=" . $tName . "&inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_MEMBER;
			$pstr = mb_convert_encoding($pstr,"SJIS", _CHARSET);
			$html = $this->getDataByUrl( $mUrl, $pstr );
			if( $html->find('input[name=no_0]') != null ){
				$mStrAry	= array();
				$iCnt		= 0;
				while( 1 ){
					$UnoNm	= "input[name=no_"		. $iCnt . "]";
					$LnNm	= "input[name=si_"		. $iCnt . "]";
					$FnNm	= "input[name=mei_"		. $iCnt . "]";
					$nDspNm	= "input[name=nodisp_"	. $iCnt . "]";
					$Uno	= $html->find($UnoNm,0);
					if( $Uno        == null  ){	break; }
					if( $Uno->value == ""    ){	break; }
					$Ln		= $html->find($LnNm,0);
					$Fn		= $html->find($FnNm,0);
					$nDsp	= $html->find($nDspNm,0);
					$mStrAry[] = $Uno->value . "," . $Ln->value . "," . $Fn->value . ",,,,,,,," . $nDsp->checked . ",,,,";
					$iCnt++;
				}
				$html->clear();
				unset($html);
				if( $mStrAry ){
					$ret = $this->insMemberFromFile( $mUrl, $mStrAry );							// ХꥹȤDBϿ
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						return $ret;
					}
				}
			} else {
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND );		// Url or password invalid
				return BBSB_FRAME_VIEW_INPUT;
			}

			// 饦()
			// 饦ɾե(gr.cgi)ǥǡ  1:饦̾
			$gUrl = $baseUrl . "/k_gr.cgi";
			$pstr = "ikzhp=" . $tName . "&inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_GROUND;
			$pstr = mb_convert_encoding($pstr,"SJIS", _CHARSET);
			$html = $this->getDataByUrl( $gUrl, $pstr );
			if( $html->find('input[name=gr]') != null ){
				$grStrAry = array();
				foreach( $html->find('input[name=gr]') as $dat ){
					if( $dat->value == "" ){	break;	}
					$grStrAry[] = $dat->value;
				}
				$html->clear();
				unset($html);
				if( $grStrAry ){
					$ret = $this->insGroundFromFile( $gUrl, $grStrAry );						// 饦ɥꥹȤDBϿ
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						return $ret;
					}
				}
			} else {
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND );		// password invalid
				return BBSB_FRAME_VIEW_INPUT;
			}

			// (꡼)
			// ꡼̾ (syusai.cgi)ǥǡ 1:꡼̾
			$lUrl = $baseUrl . "/k_syusai.cgi";
			$pstr = "ikzhp=" . $tName . "&inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_LEAGUE;
			$pstr = mb_convert_encoding($pstr,"SJIS", _CHARSET);
			$html = $this->getDataByUrl( $lUrl, $pstr );
			if( $html->find('input[name=syusai]') != null ){
				$lStrAry = array();
				foreach( $html->find('input[name=syusai]') as $dat ){
					if( $dat->value == "" ){	break;	}
					$lStrAry[] = $dat->value;
				}
				$html->clear();
				unset($html);
				if( $lStrAry ){
					$ret = $this->insLeagueFromFile( $lUrl, $lStrAry );							// ꡼ꥹȤDBϿ
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						return $ret;
					}
				}
			} else {
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND );		// password invalid
				return BBSB_FRAME_VIEW_INPUT;
			}

			// (ȡʥ)
			// ȡʥ()̾ (taikai.cgi)ǥǡ 1:ȡʥ̾
			$tUrl = $baseUrl . "/k_taikai.cgi";
			$pstr = "ikzhp=" . $tName . "&inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_TOURNAMENT;
			$pstr = mb_convert_encoding($pstr,"SJIS", _CHARSET);
			$html = $this->getDataByUrl( $tUrl, $pstr );
			if( $html->find('input[name=taikai]') != null ){
				$tStrAry = array();
				foreach( $html->find('input[name=taikai]') as $dat ){
					if( $dat->value == "" ){	break;	}
					$tStrAry[] = $dat->value;
				}
				$html->clear();
				unset($html);
				if( $tStrAry ){
					$ret = $this->insTournamentFromFile( $tUrl, $tStrAry );						// ȡʥȥꥹȤDBϿ
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						return $ret;
					}
				}
			} else {
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND );		// password invalid
				return BBSB_FRAME_VIEW_INPUT;
			}

			// (ȡʥ)
			// ̾ (kaisen.cgi) ǥǡ 1:̾
			$goUrl = $baseUrl . "/k_kaisen.cgi";
			$pstr = "ikzhp=" . $tName . "&inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_GAMEORDER;
			$pstr = mb_convert_encoding($pstr,"SJIS", _CHARSET);
			$html = $this->getDataByUrl( $goUrl, $pstr );
			if( $html->find('input[name=kaisen]') != null ){
			$goStrAry = array();
				foreach( $html->find('input[name=kaisen]') as $dat ){
					if( $dat->value == "" ){	break;	}
					$goStrAry[] = $dat->value;
				}
				$html->clear();
				unset($html);
				if( $goStrAry ){
					$ret = $this->insGameOrderFromFile( $goUrl, $goStrAry );					// ꥹȤDBϿ
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						return $ret;
					}
				}
			} else {
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND );		// password invalid
				return BBSB_FRAME_VIEW_INPUT;
			}

			// ̾Τ뤿kihon.cgi
			$goUrl = $baseUrl . "/k_kihon.cgi";
			$pstr = "ikzhp=" . $tName . "&inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_KIHON;
			$pstr = mb_convert_encoding($pstr,"SJIS", _CHARSET);
			$html = $this->getDataByUrl( $goUrl, $pstr );
			$jiteam = $html->find('input[name=jiteam]',0);
			if( $jiteam == null || $jiteam->value == "" ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_URLNOTFOUND );
				return BBSB_FRAME_VIEW_INPUT;
			}
			$ownTeamName = mb_convert_encoding( $jiteam->value, _CHARSET, "SJIS" );		// ʸѴ

			// ̰ڡڡ
			$gUrl = $baseUrl . "/k_menu.cgi";		// ̰ڡ
			$pstr = "ikzhp=" . $tName . "&inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_MENU;
			$pstr = mb_convert_encoding($pstr,"SJIS", _CHARSET);
			$html = $this->getDataByUrl( $gUrl, $pstr );
			// ڡ롣
			$pagenum = 1;
			if( $html->find('a[href^=./k_menu.cgi]') != null ){
				foreach( $html->find('a[href^=./k_menu.cgi]') as $link ){
					$query = explode( '?', $link->href );
					if( count($query) == 2){
						parse_str( $query[1], $output );
						if( isset($output['page']) ){
							if( $pagenum < $output['page'] ){
								$pagenum = $output['page'];
							}
						}
					}
				}
			}

			// ̰ڡƤΥڡʬž
			for( $pCnt = 0 ; $pCnt < $pagenum ; $pCnt++ ){
				$gUrl = $baseUrl . "/k_menu.cgi?page=" . ($pCnt+1) . "&inpass=" . $ikzpass . "&ikzhp=" . $tName;	// ̰ڡ
				$html = $this->getDataByUrl( $gUrl );

				// ̾ܺ٤
				foreach( $html->find('input[name=nen]') as $rcnt => $rdat ){

					// ʤ߾郎оݤΥ쥳ɤΤܹ߰Ԥ롣
					if( $this->mActionForm->get('RefineYear') ){
						if( $this->mActionForm->get('RefineYear') != $html->find('input[name=nen]',$rcnt)->value ){
							continue;
						}
						if( $this->mActionForm->get('RefineMonth') ){
							if( $this->mActionForm->get('RefineMonth') != $html->find('input[name=tuki]',$rcnt)->value ){
								continue;
							}
						}
					}

					$gdUrl = $baseUrl . "/k_seiseki.cgi?key=nor";
					$pstr = "inpass=" . $ikzpass . "&submit=" . _MD_BBSB_LANG_IKZ_MODIFY
							. "&nen="   . $html->find('input[name=nen]'  , $rcnt)->value
							. "&tuki="  . $html->find('input[name=tuki]' , $rcnt)->value
							. "&hi="    . $html->find('input[name=hi]'   , $rcnt)->value
							. "&dai="   . $html->find('input[name=dai]'  , $rcnt)->value
							. "&nendo=" . $html->find('input[name=nendo]', $rcnt)->value
							. "&ikzhp="  . $tName;
					$pstr = mb_convert_encoding($pstr, "SJIS", _CHARSET );
					$htmld = $this->getDataByUrl( $gdUrl, $pstr );
					if( $htmld->find('select[name=nen]') == null ){
						$htmld->clear();
						unset($htmld);
						continue;
					}
					$gdat = array();
					$gdat[] = "dai=" . $html->find('input[name=dai]' , $rcnt)->value;					// 

					$gdat[]	= "taikai="		. $this->getSelectOpt( $htmld, 'select[name=taikai]');		// 
					$gdat[]	= "kai="		. $this->getSelectOpt( $htmld, 'select[name=kai]');			// 
					$gdat[]	= "syusai="		. $this->getSelectOpt( $htmld, 'select[name=syusai]');		// 
					$gdat[]	= "nendo="		. $this->getSelectOpt( $htmld, 'select[name=nendo]');		// ǯ
					$gdat[]	= "gr="			. $this->getSelectOpt( $htmld, 'select[name=gr]');			// 饦
					$gdat[]	= "katimake="	. $this->getSelectOpt( $htmld, 'select[name=katimake]');	// 
					$gdat[] = "msg="		. $htmld->find('textarea[name=msg]' ,0)->innertext;			// 
					$gdat[] = "senb="		. $htmld->find('input[name=senb]' ,0)->value;				// 蹶Хåƥ꡼
					$gdat[] = "koub="		. $htmld->find('input[name=koub]' ,0)->value;				// 蹶Хåƥ꡼
					$gdat[] = "sen="		. $htmld->find('input[name=sen0]' ,0)->value . ","			// 蹶 0:̾1:ס2:()314
											. $htmld->find('input[name=sen1]' ,0)->value . ",*,"
											. $htmld->find('input[name=sen3]' ,0)->value . ","
											. $htmld->find('input[name=sen4]' ,0)->value . ","
											. $htmld->find('input[name=sen5]' ,0)->value . ","
											. $htmld->find('input[name=sen6]' ,0)->value . ","
											. $htmld->find('input[name=sen7]' ,0)->value . ","
											. $htmld->find('input[name=sen8]' ,0)->value . ","
											. $htmld->find('input[name=sen9]' ,0)->value . ","
											. $htmld->find('input[name=sen10]',0)->value . ","
											. $htmld->find('input[name=sen11]',0)->value . ","
											. $htmld->find('input[name=sen12]',0)->value . ","
											. $htmld->find('input[name=sen13]',0)->value . ","
											. $htmld->find('input[name=sen14]',0)->value;
					$gdat[] = "kou="		. $htmld->find('input[name=kou0]' ,0)->value . ","			// 并 0:̾1:ס2:()314
											. $htmld->find('input[name=kou1]' ,0)->value . ",*,"
											. $htmld->find('input[name=kou3]' ,0)->value . ","
											. $htmld->find('input[name=kou4]' ,0)->value . ","
											. $htmld->find('input[name=kou5]' ,0)->value . ","
											. $htmld->find('input[name=kou6]' ,0)->value . ","
											. $htmld->find('input[name=kou7]' ,0)->value . ","
											. $htmld->find('input[name=kou8]' ,0)->value . ","
											. $htmld->find('input[name=kou9]' ,0)->value . ","
											. $htmld->find('input[name=kou10]',0)->value . ","
											. $htmld->find('input[name=kou11]',0)->value . ","
											. $htmld->find('input[name=kou12]',0)->value . ","
											. $htmld->find('input[name=kou13]',0)->value . ","
											. $htmld->find('input[name=kou14]',0)->value . ","
											. $htmld->find('input[name=kou1]' ,0)->value;

					// da= ϤޤԤν 0:̾1:ֹ桢2:ǽ(1)3:(1)4:5:֡6:71819:20ݼԡ21()
					foreach( $htmld->find('input[name=da_jun]')  as $idx => $ddat ){
						if($ddat->value == "" ){ continue; }
						$dpos	= strrpos( $htmld->find('input[name=da_simei]' ,$idx)->value, "#" );
						$name	= substr( $htmld->find('input[name=da_simei]' ,$idx)->value, 0, $dpos );	// ̾
						$uno	= substr( $htmld->find('input[name=da_simei]' ,$idx)->value, $dpos+1 );		// ֹ
						$fplay	= "";
						if( $htmld->find('input[name=da_fplay]') != null ){									// פ
							$fplay = $htmld->find('input[name=da_fplay]' ,$idx)->value;
						}
						$gdat[] = "da="	. $name . "," . $uno . "," . $htmld->find('input[name=da_jun]' ,$idx)->value . ","
								. $htmld->find('select[name=da_chg]',$idx)->find('option[selected]',0)->value . ","
								. $htmld->find('input[name=da_torui]' ,$idx)->value . ","
								. $htmld->find('input[name=da_syubi]' ,$idx)->value . ","
								. $htmld->find('input[name=da_err]' ,$idx)->value . ","
								. $htmld->find('input[name=da_1]' ,$idx)->value . ","
								. $htmld->find('input[name=da_2]' ,$idx)->value . ","
								. $htmld->find('input[name=da_3]' ,$idx)->value . ","
								. $htmld->find('input[name=da_4]' ,$idx)->value . ","
								. $htmld->find('input[name=da_5]' ,$idx)->value . ","
								. $htmld->find('input[name=da_6]' ,$idx)->value . ","
								. $htmld->find('input[name=da_7]' ,$idx)->value . ","
								. $htmld->find('input[name=da_8]' ,$idx)->value . ","
								. $htmld->find('input[name=da_9]' ,$idx)->value . ","
								. $htmld->find('input[name=da_10]' ,$idx)->value . ","
								. $htmld->find('input[name=da_11]' ,$idx)->value . ","
								. $htmld->find('input[name=da_12]' ,$idx)->value . ","
								. $htmld->find('input[name=da_tokuten]' ,$idx)->value . ","
								. $htmld->find('input[name=da_toruix]' ,$idx)->value . ","
								. $fplay;
					}
					$skai = "";
					foreach( $htmld->find('input[name=skai]') as $inning ){
						if( $skai ){
							$skai .= ",";
						}
						$skai .= $inning->value;
					}
					$gdat[] = "skai=" . $skai;

					// to= ϤޤԤν 0:ֹ桢1:̾2:˥󥰡3:ȥȡ4:5:6:å7:Ϳ͵塢8:Ϳ塢9:ǡ10:ǡ11:12:ԡ13:˽ꡩ()
					foreach( $htmld->find('input[name=to_0]') as $idx => $pdat ){
						if( $pdat->value == "" ){ continue; }
						$dpos	= strrpos( $htmld->find('input[name=to_0]' ,$idx)->value, "#" );
						$name	= substr( $htmld->find('input[name=to_0]' ,$idx)->value, 0, $dpos );	// ̾
						$uno	= substr( $htmld->find('input[name=to_0]' ,$idx)->value, $dpos+1 );		// ֹ
						$result = $this->getSelectOpt( $htmld, 'select[name=to_12]', $idx );			// Է̼
						if( !$result ){ $result = 0; }
						$wp = "";
						if( $htmld->find('input[name=to_13]') != null ){								// ˽פ
							$wp = $htmld->find('input[name=to_13]' ,$idx)->value;
						}
						$gdat[] = "to="	. $uno . "," . $name . ","
								. $htmld->find('input[name=to_2]' ,$idx)->value . ","
								. $htmld->find('input[name=to_3]' ,$idx)->value . ","
								. $htmld->find('input[name=to_4]' ,$idx)->value . ","
								. $htmld->find('input[name=to_5]' ,$idx)->value . ","
								. $htmld->find('input[name=to_6]' ,$idx)->value . ","
								. $htmld->find('input[name=to_7]' ,$idx)->value . ","
								. $htmld->find('input[name=to_8]' ,$idx)->value . ","
								. $htmld->find('input[name=to_9]' ,$idx)->value . ","
								. $htmld->find('input[name=to_10]' ,$idx)->value . ","
								. $htmld->find('input[name=to_11]' ,$idx)->value . ","
								. $result . ","
								. $wp;
					}
					$htmld->clear();
					unset($htmld);

					// ǡݡ
					$EventDate	= $html->find('input[name=nen]' , $rcnt)->value . "-"
								. $html->find('input[name=tuki]', $rcnt)->value . "-"
								. $html->find('input[name=hi]'  , $rcnt)->value;		// 糫
					$GameSeq	= $html->find('input[name=dai]' , $rcnt)->value;		// 
					$GameIdnt	= $EventDate . " - " . $GameSeq;
					$ret = $this->insGameFromFile( $GameIdnt, $gdat, $EventDate, $GameSeq, $ownTeamName );
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						return $ret;
					}
				}
				$html->clear();
				unset($html);
			}

		} else {
			// TODO ǥ쥯ȥѥʳ
			//  եľܥåץɤʤɡ

		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("admin_switchover.html");
		$render->setAttribute("actionForm", $this->mActionForm);
		$render->setAttribute("timestr",	$this->mTimeStr);
	}

	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
	}

	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
	}

	/**
	 * СꥹȤɤ߹bb_menbar롣
	 * ̾ʸNickName¸ߤƤϤǤ˥СϿƤȤߤʤINSERTԤʤ
	 * @param $uri			ե̾ޤURL
	 * @param $f			ե
	 * @return unknown_type
	 */
	function insMemberFromFile( $uri, $f )
	{
		$dbMem = new BBSB_DbMember();
		foreach( $f as $key => $buf ){
			$buf = mb_convert_encoding( $buf, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode( ',', $buf );
			$dbMem->unsetData();
			$name = $lst[1] . $lst[2];
			$dbMem->setData('NickName', $name);
			$ret = $dbMem->CountNum('bb_member');					// NickNameˡס̾פʸ¸ߤƤ餹Ǥ¸ߤȤߤʤ
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$name = $lst[1] . $lst[2];
				$dbMem->setData('FullName',		$name);				// ̾ȥ˥å͡ϤȤꤢƱΤ򥻥å
				$dbMem->setData('NickName',		$name);
				$dbMem->setData('UniformNo',	$lst[0]);
				$s = $lst[10]? 0 : 1;								// ScoreEntryϲդ˥åȤ롣
				$dbMem->setData('ScoreEntry',	$s);
				$val = '1';
				$dbMem->setData('ProfileEntry',	$val);				// ץեϿϥǥեȤON
				$rc = $dbMem->insert('bb_member');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":MemberData:"  . $lst[1] . $lst[2] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":MemberData:" . $uri );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * 饦ɥꥹȤɤ߹bb_ground롣
	 * @param $uri			ե̾ޤURL
	 * @param $f			ե
	 * @return unknown_type
	 */
	function insGroundFromFile( $uri, $f )
	{
		$dbGr = new BBSB_DbGround();
		foreach( $f as $key => $buf ){
			$buf = mb_convert_encoding( $buf, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode( ',', $buf );
			$dbGr->unsetData();
			$dbGr->setData('GroundName', $lst[0]);
			$ret = $dbGr->CountNum('bb_ground');					// ̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbGr->insert('bb_ground');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GroundData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":GroundData:" . $uri );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ꡼()ꥹȤɤ߹bb_league롣
	 * @param $uri			ե̾ޤURL
	 * @param $f			ե
	 * @return unknown_type
	 */
	function insLeagueFromFile( $uri, $f )
	{
		$dbLe = new BBSB_DbLeague();
		foreach( $f as $key => $dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode(',',$dat);
			$dbLe->unsetData();
			$dbLe->setData('LeagueName', $lst[0]);
			$ret = $dbLe->CountNum('bb_league');					// ꡼̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbLe->insert('bb_league');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":LeagueData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":LeagueData:" . $uri );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ȡʥ()ꥹȤɤ߹bb_tournament롣
	 * @param $uri			ե̾ޤURL
	 * @param $f			ե
	 * @return unknown_type
	 */
	function insTournamentFromFile( $uri, $f )
	{
		$dbTr = new BBSB_DbTournament();
		foreach( $f as $key => $dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode(',',$dat);
			$dbTr->unsetData();
			$dbTr->setData('TournamentName', $lst[0]);
			$ret = $dbTr->CountNum('bb_tournament');					// ȡʥ̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbTr->insert('bb_tournament');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":TournamentData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":TournamentData:" . $uri );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ꥹȤɤ߹bb_gameorder롣
	 * @param $uri			ե̾ޤURL
	 * @param $f			ե
	 * @return unknown_type
	 */
	function insGameOrderFromFile( $uri, $f )
	{
		$dbGO = new BBSB_DbGameOrder();
		foreach( $f as $key => $dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode(',',$dat);
			$dbGO->unsetData();
			$dbGO->setData('GameOrderName', $lst[0]);
			$ret = $dbGO->CountNum('bb_gameorder');					// ̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbGO->insert('bb_gameorder');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameOrderData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":GameOrderData:" . $uri );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ꥹȤɤ߹bb_game롣
	 * @param $uri			ե̾ޤURL
	 * @param $f			ե(1Ԥ1ǤȤ)
	 * @param $EventDate	糫(yyyymmdd)
	 * @param $GameSeq		(1-9)
	 * @param $ownTeamName	̾
	 * @return unknown_type
	 */
	function insGameFromFile( $uri, $f, $EventDate, $GameSeq, $ownTeamName )
	{
		// ʸѴ
		foreach( $f as $key => &$dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );
		}
		$dbGa = new BBSB_DbGame();						// ơ֥륤󥹥

		// ̾DBϿƤʤХơ֥Ͽ
		$TournamentID		= null;
		$TournamentName		= substr( strstr($f[1],'='), 1);	//̾
		if( $TournamentName ){
			$dbTr				= new BBSB_DbTournament();
			$dbTr->setData( 'TournamentName', $TournamentName );
			$ret = $dbTr->getListbyCond( 'bb_tournament', 'TournamentID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbTr->insert('bb_tournament');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Tournament:"  . $TournamentName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$TournamentID = $dbTr->mDb->getInsertId();
				if( !$TournamentID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Tournament:"  . $TournamentName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$TournamentID = $ret[0]['TournamentID'];
			}
		}

		// ̾DBϿƤʤХơ֥Ͽ
		$GameOrderID		= null;
		$GameOrderName		= substr( strstr($f[2],'='), 1);	// ̾
		if( $GameOrderName ){
			$dbGO				= new BBSB_DbGameOrder();
			$dbGO->setData( 'GameOrderName', $GameOrderName );
			$ret = $dbGO->getListbyCond( 'bb_gameorder', 'GameOrderID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbGO->insert('bb_gameorder');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameOrder:"  . $GameOrderName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$GameOrderID = $dbGO->mDb->getInsertId();
				if( !$GameOrderID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameOrder:"  . $GameOrderName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$GameOrderID = $ret[0]['GameOrderID'];
			}
		}

		// ̾(꡼̾)DBϿƤʤХơ֥Ͽ
		$LeagueID			= null;
		$LeagueName			= substr( strstr($f[3],'='), 1);	// ꡼̾
		if( $LeagueName ){
			$dbLg				= new BBSB_DbLeague();
			$dbLg->setData( 'LeagueName', $LeagueName );
			$ret = $dbLg->getListbyCond( 'bb_league', 'LeagueID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbLg->insert('bb_league');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":League:"  . $LeagueName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$LeagueID = $dbLg->mDb->getInsertId();
				if( !$LeagueID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":League:"  . $LeagueName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$LeagueID = $ret[0]['LeagueID'];
			}
		}

		// ǯټ
		$Nendo				= substr( strstr($f[4],'='), 1);	// ǯ

		// 饦̾DBϿƤʤХơ֥Ͽ
		$GroundID			= null;
		$GroundName			= substr( strstr($f[5],'='), 1);	// 饦̾
		if( $GroundName ){
			$dbGr				= new BBSB_DbGround();
			$dbGr->setData( 'GroundName', $GroundName );
			$ret = $dbGr->getListbyCond( 'bb_ground', 'GroundID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbGr->insert('bb_ground');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Ground:"  . $GroundName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$GroundID = $dbGr->mDb->getInsertId();
				if( !$GroundID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Ground:"  . $GroundName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$GroundID = $ret[0]['GroundID'];
			}
		}

		// (祳)
		$GameComennt = "";
		$f[7] = str_replace( 'msg=', '', $f[7] );	// "msg=" ʸ
		for( $rcnt = 7 ; $rcnt < count($f) ; $rcnt++ ){
			if( substr($f[$rcnt], 0, 5) == 'senb=' ){
				break;		// ΥãΤǽλ
			}
			$GameComennt .= $f[$rcnt] . "\n";
		}

		// 蹶Хåƥ꡼
		$FirstBattery		= substr( strstr($f[$rcnt],'='), 1);	// 蹶Хåƥ꡼
		$rcnt++;
		// 并Хåƥ꡼
		$LastBattery		= substr( strstr($f[$rcnt],'='), 1);	// 并Хåƥ꡼
		$rcnt++;

		// 蹶并
		$Fidx	= $rcnt; $rcnt++;
		$Lidx	= $rcnt; $rcnt++;
		$FirstTeamID = $LastTeamID = null;
		$lFirst	= explode( ',', substr( strstr($f[$Fidx],'='), 1) );	// 蹶 0:̾1:ס2:()314
		$lLast	= explode( ',', substr( strstr($f[$Lidx],'='), 1) );	// 并

		// ̾DBϿƤʤХơ֥Ͽ
		$FirstTeamID = $LastTeamID = null; // 
		if( strpos( $f[$Fidx], $ownTeamName ) > 0 ){		// 蹶ξ
			$FirstTeamID	= 0;							// TeamIDȤƼ(=0)򥻥å
		}
		if( strpos( $f[$Lidx], $ownTeamName ) > 0 ){		// 并फɤ
			$LastTeamID		= 0;							// TeamIDȤƼ(=0)򥻥å
		}
		if( $FirstTeamID === null ){
			$ret = $this->insTeam( $lFirst[0], $EventDate, $FirstTeamID );
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return BBSB_FRAME_VIEW_INPUT;
			}
		}
		if( $LastTeamID === null ){
			$ret = $this->insTeam( $lLast[0], $EventDate, $LastTeamID );
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return BBSB_FRAME_VIEW_INPUT;
			}
		}

		// Ƚ
		$Result			= null;
		$katimake		=substr( strstr($f[6],'='), 1);			// 
		switch( $katimake ){
			case '0':	// 0嵭̤
				if( $ownTeamName == $lFirst[0] && $ownTeamName != $lLast[0] ){			// ब蹶ΤȤ
					if( $lFirst[1] > $lLast[1] ){
						$Result = '1';							// 蹶ξϼྡ
					} else if( $lFirst[1] < $lLast[1] ){
						$Result = '0';							// 并ξϼ餱
					} else {
						$Result = '2';							// ʬ
					}
				} else if( $ownTeamName != $lFirst[0] && $ownTeamName == $lLast[0] ){	// ब并ΤȤ
					if( $lFirst[1] > $lLast[1] ){
						$Result = '0';							// 蹶ξϼ餱
					} else if( $lFirst[1] < $lLast[1] ){
						$Result = '1';							// 并ξϼྡ
					} else {
						$Result = '2';							// ʬ
					}
				} else {
					$Result = '3';								// ¾ (ʤ)
				}
				break;
			case '1':	// 1:
				$Result = '11';									// 11:
				break;
			case '2':	// 2:ﾡ
				$Result = '21';									// 21:ﾡ
				break;
			case '3':	// 3:¾
				$Result = '31';									// 31:¾
				break;
			case '11':	// 11:餱
				$Result = '10';									// 10:餱
				break;
			case '12':	// 12:
				$Result = '20';									// 20:
				break;
			case '13':	// 13:¾餱
				$Result = '30';									// 30:¾餱
				break;
		}

		// Ƿǡ
		// da= ϤޤԤν 0:̾1:ֹ桢2:ǽ(1)3:(1)4:5:֡6:71819:20ݼԡ21()
		$lB		= array();
		$dbM	= new BBSB_DbMember();
		$dcnt	= 0;// Ǽԥ
		$ocnt	= 1;// ǽ祫(1)
		$chgcnt = 0;// 祫
		while( substr($f[$rcnt],0,3) == "da=" ){
			$Dbuf	= explode( ',', substr( strstr($f[$rcnt],'='), 1) );
			if( $dcnt > 0 ){
				if( $Dbufp[2] == $Dbuf[2] ){	// ǽ礬Ʊϸ򣱤䤹
					$chgcnt++;
				} else {
					$chgcnt = 0;
					$ocnt++;					// ǽ礬㤦ǽ祫䤹
				}
			}

			// Ǽֹ̾Ǽ̾DBϿƤʤХХơ֥Ͽ
			$dbM->unsetData();
			$dbM->setData( 'NickName', $Dbuf[0] );		// Ȥꤢ˥å͡򥭡Ƚ
			$ret = $dbM->getListbyCond('bb_member','UserID');
			if( $ret == null ){
				$dbM->setData( 'FullName',	$Dbuf[0] );
				$dbM->setData( 'UniformNo', $Dbuf[1] );	// ֹ
				$ret = $dbM->insert('bb_member');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Dbuf[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
				// INSERT줿UserID롣
				$lB[$dcnt]['UserID'] = $dbM->mDb->getInsertId();
				if( !$lB[$dcnt]['UserID'] ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Dbuf[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$lB[$dcnt]['UserID'] = $ret[0]['UserID'];
			}
			$lB[$dcnt]['PlayOrder']		= $ocnt;							// ǽ
			$lB[$dcnt]['ChangeCnt']		= $chgcnt;							// 
			$lB[$dcnt]['Position1']		= intval($Dbuf[5])?  	intval($Dbuf[5]) : null;	// 1 (0NULLȤ)
			$lB[$dcnt]['Position2']		= null;								// ݥ2ϤʤΤnull򥻥å
			$lB[$dcnt]['StolenBaseSuc']	= $Dbuf[4]!=''?  $Dbuf[4] : null;	// 
			$lB[$dcnt]['StolenBaseFail']= $Dbuf[20]!=''? $Dbuf[20]: null;	// ݼ
			$lB[$dcnt]['RunsCnt']		= $Dbuf[19]!=''? $Dbuf[19]: null;	// 
			$lB[$dcnt]['ErrorsCnt']		= $Dbuf[6]!=''?  $Dbuf[6] : null;	// 
			if( isset($Dbuf[21]) ){
				$lB[$dcnt]['BP']		= $Dbuf[21]!=''?  $Dbuf[21] : null;	// 
			}
			// ˥襹롼
			for( $ccnt = 7 ; $ccnt < 19 ; $ccnt++ ){
				// 
				$Ibuf = $Dbuf[$ccnt];
				if( strpos( $Ibuf, '.' ) ){
					$lD	=  explode( '.', $Ibuf );
					$lB[$dcnt]['Direction'][$ccnt-7]		= $lD[0];
					$Ibuf = $lD[1];
				} else {
					$lB[$dcnt]['Direction'][$ccnt-7]		= null;
				}
				// 桢
				if( strpos( $Ibuf, '/' ) ){
					$lD	=  explode( '/', $Ibuf );
					$lB[$dcnt]['ScoreMarkID'][$ccnt-7]	= $lD[0];
					$lB[$dcnt]['RBI'][$ccnt-7]			= $lD[1];
				} else {
					$lB[$dcnt]['ScoreMarkID'][$ccnt-7]	= $Ibuf;
					$lB[$dcnt]['RBI'][$ccnt-7]			= null;
				}
			}
			$Dbufp	= $Dbuf;	// 1Υǡ¸
			$dcnt++;
			$rcnt++;
		}

		// ˥
		$Inlist	= explode( ',', substr( strstr($f[$rcnt],'='), 1) );
		$rcnt++;

		// ˥ͤǷǡδ֤礬äƤʤå롣
		//	˥ͤäƤʤΤˡǷǡϤƤϥ顼ˤ롣
		for( $icnt = 0 ; $icnt < 12 ; $icnt++ ){
			if( $Inlist[$icnt] == "" ){
				foreach( $lB as $key => &$dat ){
					if( $dat['ScoreMarkID'][$icnt] ){
						$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_INNINGSCOREUNMATCH );
						return BBSB_FRAME_VIEW_INPUT;
					}
				}
			}
		}

		// ǡ
		// to= ϤޤԤν 0:ֹ桢1:̾2:˥󥰡3:ȥȡ4:5:6:å7:Ϳ͵塢8:Ϳ塢9:ǡ10:ǡ11:12:ԡ13:˽ꡩ()
		$lP		= array();
		$dbM	= new BBSB_DbMember();
		$pcnt	= 0;// ǡ
		if( isset($f[$rcnt]) ){
			while( substr($f[$rcnt],0,3) == "to=" ){
				$Pbuf	= explode( ',', substr( strstr($f[$rcnt],'='), 1) );

				// ֹ̾̾DBϿƤʤХХơ֥Ͽ
				$dbM->setData( 'NickName', $Pbuf[1] );
				$ret = $dbM->getListbyCond('bb_member','UserID');
				if( $ret == null ){
					$dbM->setData( 'UniformNo', $Pbuf[0] );	// ֹ
					$ret = $dbM->insert('bb_member');
					if( $ret === false ){
						$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Pbuf[1] );
						return BBSB_FRAME_VIEW_INPUT;
					}
					// INSERT줿UserID롣
					$lP[$pcnt]['UserID'] = $dbM->mDb->getInsertId();
					if( !$lP[$pcnt]['UserID'] ){
						$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Pbuf[1] );
						return BBSB_FRAME_VIEW_INPUT;
					}
				} else {
					$lP[$pcnt]['UserID'] = $ret[0]['UserID'];
				}
				$lP[$pcnt]['ChangeCnt']		= $pcnt;
				$lP[$pcnt]['Innings']		= $Pbuf[2]!=''?  $Pbuf[2] : null;
				$lP[$pcnt]['OutCnt']		= $Pbuf[3]!=''?  $Pbuf[3] : null;
				$lP[$pcnt]['EarnedRuns']	= $Pbuf[4]!=''?  $Pbuf[4] : null;
				$lP[$pcnt]['Runs']			= $Pbuf[5]!=''?  $Pbuf[5] : null;
				$lP[$pcnt]['KCnt']			= $Pbuf[6]!=''?  $Pbuf[6] : null;
				$lP[$pcnt]['BCnt']			= $Pbuf[7]!=''?  $Pbuf[7] : null;
				$lP[$pcnt]['DBCnt']			= $Pbuf[8]!=''?  $Pbuf[8] : null;
				$lP[$pcnt]['HCnt']			= $Pbuf[9]!=''?  $Pbuf[9] : null;
				$lP[$pcnt]['HRCnt']			= $Pbuf[10]!=''? $Pbuf[10]: null;
				$lP[$pcnt]['NumOfPitch']	= $Pbuf[11]!=''? $Pbuf[11]: null;
				$lP[$pcnt]['Win'] = $lP[$pcnt]['Lose'] = $lP[$pcnt]['Save'] = $lP[$pcnt]['Hold'] = 0;
				if( $Pbuf[12] == '1' ){			// 
					$lP[$pcnt]['Win']	= 1;
				} else if( $Pbuf[12] == '2' ){	// 餱
					$lP[$pcnt]['Lose']	= 1;
				} else if( $Pbuf[12] == '3' ){	// 
					$lP[$pcnt]['Save']	= 1;
				}
				if( isset($Pbuf[13]) ){	// ˽
					$lP[$pcnt]['WildPitch']	= $Pbuf[13]!=''? $Pbuf[13]: null;
				}
				$pcnt++;
				$rcnt++;
				if( !isset($f[$rcnt]) ){ break; }
			}
		}
		// ơ֥Ͽ(bb_game)
		$dbGa->unsetData();
		// դȻ礬פǡϿϹԤʤ
		$dbGa->setData( 'EventDate',	$EventDate );
		$dbGa->setData( 'GameSeq',		$GameSeq );
		if( $dbGa->CountNum('bb_game') > 0 ){
			// 礬ϿƤΤǽλ
			$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_ALREADYEXISTS . ":" . $uri );
			return BBSB_FRAME_VIEW_SUCCESS;
		}

		// 礬ϿƤʤȤǧǤΤǻϿ
		$dbGa->setData( 'Nendo',		$Nendo );
		$dbGa->setData( 'LeagueID',		$LeagueID );
		$dbGa->setData( 'TournamentID',	$TournamentID );
		$dbGa->setData( 'GameOrderID',	$GameOrderID );
		$dbGa->setData( 'Groundid',		$GroundID );
		$dbGa->setData( 'Result',		$Result );
		$dbGa->setData( 'FirstTeamID',	$FirstTeamID );
		$dbGa->setData( 'LastTeamID',	$LastTeamID );
		$dbGa->setData( 'FirstBattery',	$FirstBattery );
		$dbGa->setData( 'LastBattery',	$LastBattery );
		$dbGa->setData( 'GameComment',	$GameComennt );
		for( $icnt = 0 ; $icnt < 12 ; $icnt++ ){
			$seqstr = sprintf("%02d", $icnt+1);
			$inningtop 		= "Inning" . $seqstr . "top";
			$inningbottom	= "Inning" . $seqstr . "bottom";
			$fscore=null;
			if( $lFirst[$icnt+3]!="" ){
				$fscore=$lFirst[$icnt+3];
			}
			$lscore=null;
			if( $lLast[$icnt+3]!="" ){
				$lscore=$lLast[$icnt+3];
			}
			$dbGa->setData( $inningtop,		$fscore );
			$dbGa->setData( $inningbottom,	$lscore  );
		}
		$dbGa->setData( 'ResultTop',	$lFirst[1] );
		$dbGa->setData( 'ResultBottom',	$lLast[1] );
		$nowstr = 'NOW()';
		$dbGa->setData( 'UpdateTime',	$nowstr );
		$result = $dbGa->insert( 'bb_game' );
		if( $result===false ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Game:"  . $uri );
			return BBSB_FRAME_VIEW_INPUT;
		}
		// INSERT줿GameID롣
		$gid = $dbGa->mDb->getInsertId();
		if( !$gid ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Game:"  . $uri );
			return BBSB_FRAME_VIEW_INPUT;
		}

		// üԥơ֥Ͽ(bb_gameentrant)
		$ret = $this->insEntrantData( $gid, $lB );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameEntrant:"  . $uri );
			return $ret;
		}

		// Хåơ֥Ͽ(bb_gamebatter)
		$ret = $this->insBatterData( $gid, $Inlist, $lB );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameBatter:"  . $uri );
			return $ret;
		}

		// ԥå㡼ơ֥Ͽ(bb_gamepitcer)
		$ret = $this->insPitcherData( $gid, $lP );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			return $ret;
		}

		// Message
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":GameData:" . $uri );

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ϤȤ̾DBϿƤʤϿ롣
	 * ޤǽդй롣
	 * @param $TeamName  IN)̾()
	 * @param $GameDate  IN)(8yyyymmdd)
	 * @param $TeamID    (OUT)ID
	 * @return unknown_type
	 */
	function insTeam( $TeamName, $GameDate, &$TeamID ){
		// ơ֥¸ߤ뤫ɤĴ١ʤХơ֥Ͽ
		$dbOp = new BBSB_DbOpponent();
		$dbOp->setData( 'TeamName', $TeamName );
		$ret = $dbOp->getListbyCond( 'bb_opponent','TeamID,LastGameDate');
		if( $ret == null ){
			// DBϿƤʤȤINSERT
			$dbOp->setData( 'LastGameDate', $GameDate );
			$ret = $dbOp->insert('bb_opponent');
			if( $ret === false ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Opponent:"  . $TeamName );
				return BBSB_FRAME_VIEW_INPUT;
			}
			$TeamID = $dbOp->mDb->getInsertId();
			if( !$TeamID ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Opponent:"  . $TeamName );
				return BBSB_FRAME_VIEW_INPUT;
			}
		} else {
			//  Ǥ쥳ɤ¸ߤƤ
			$TeamID = $ret[0]['TeamID'];
			// ǽդɤؤ뤫ɤΥåԤ
			$spos = strpos( $ret[0]['LastGameDate'], ' ');
			if( $spos > 0 ){
				$lastdate = substr( $ret[0]['LastGameDate'], 0, $spos );
				$lastdate = str_replace( '-', '', $lastdate );
				if( strcmp($GameDate, $lastdate)>0 ){
					$dbOp->unsetData();
					$dbOp->setData( 'LastGameDate', $GameDate );
					$keyarray = array( 'TeamID'=>$TeamID );
					$result = $dbOp->update( 'bb_opponent', $keyarray );
				}
			}
		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ꤷURLǡФѡ֥Ȥ֤
	 * 		simple_html_dom.php Call¦requireƤȡ
	 * 		url,postʸϡ󥳡ɺѤߤǤ뤳ȡ
	 * @param $url
	 * @param $poststr
	 * @return unknown_type
	 */
	function getDataByUrl( $url, $poststr=null ){
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		if( $poststr ){
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $poststr);
		}
		$data = curl_exec( $ch );
		//$data = mb_convert_encoding ( $data, "UTF-8","SJIS");
		curl_close($ch);
		return str_get_html($data);
	}

	/**
	 * <select>~</select>ϤơselectƤ륢ƥ롣
	 * selectʤ""(ʸ)֤
	 *	(HTMLιʸ<option>~</option>ĤƤʤʹʸʤΤǡDOM Perserεǽ򤽤Τޤ޻Ȥʤ
	 *	 Ǥϡ¿Ĺˤʤ뤬ʸԤͤƤ롣)
	 * @param $domobj	DOM PerserΥ֥
	 * @param $skey		DOM PerserfindؿǻȤ  'select[name=taikai]' ʤɡ
	 * @param $idx		$skey륿ΤnܤΥꤹ롣
	 * @return unknown_type
	 */
	function getSelectOpt( $domobj, $skey, $idx=0 )
	{
		$seltext	= $domobj->find($skey,$idx)->innertext;
		$seltext	= substr( $seltext, 0, stripos($seltext,"</select>"));		// selectȥƥȤ
		$sobj		= str_get_html($seltext);
		$item		= "";
		if( isset($sobj->find('option[selected]',0)->value) ){	// "selected"ƥबФͤʤ""ʸ
			$item = $sobj->find('option[selected]',0)->value;
		}
		$sobj->clear();
		unset($sobj);
		return $item;
	}

}
?>
