<?php
// メッセージファイル

// カレンダーファイル(common/jscalender/lang/下)
define('_MD_BBSB_JS_CALENDAR',				'calendar-jp-utf8.js') ;

// ERROR
define('_MD_BBSB_ERROR_DATABASEUPDATE',		"データベース処理に失敗しました");
define('_MD_BBSB_ERROR_REQUIRED',			"{0}は必ず入力して下さい");
define('_MD_BBSB_ERROR_MAXLENGTH',			"{0}は半角{1}文字以内で入力して下さい");
define('_MD_BBSB_ERROR_INTRANGE',			"{0}に対して不正な入力です");
define('_MD_BBSB_ERROR_INJURY',				"{0}の入力値が不正です");
define('_MD_BBSB_ERROR_EMAIL',				"不正なメールアドレスが入力されています");
define('_MD_BBSB_ERROR_BATSCORE1',			"打撃成績:(行,列)=(");
define('_MD_BBSB_ERROR_BATSCORE2_DIR',		":打撃方向は1-9の間で指定してください");
define('_MD_BBSB_ERROR_BATSCORE2_RBI',		":打点は1-9の間で指定してください");
define('_MD_BBSB_ERROR_BATSCORE2_SCOREMARK',":打撃種類が不正です");
define('_MD_BBSB_ERROR_INNINGHEAD',			"打撃成績表の上部にあるイニング数字をが正しく入力してください。");
define('_MD_BBSB_ERROR_INNINGSCOREUNMATCH',	"打撃成績表の上部にあるイニング数字が空白であるにもかかわらず、その回にスコアが入力されています。");
define('_MD_BBSB_ERROR_DUPLICATEGAME',		"すでにその日の同じ試合順でレコードが存在します。日付か試合順を変更してください");
define('_MD_BBSB_ERROR_DUPLICATE',			"すでに同じ{0}が登録されています。登録するには別の名前を指定してください");
define('_MD_BBSB_ERROR_DUPLICATEORDER',		"打撃成績入力表で、打順が重複しています");
define('_MD_BBSB_ERROR_ORDERASMEMBER',		"打順番号と選手名はセットで入力してください");
define('_MD_BBSB_ERROR_ORDERASUNO',			"打順番号と背番号はセットで入力してください。");
define('_MD_BBSB_ERROR_WINNINGRUN',			"勝利打点は1つしかチェックできません");
define('_MD_BBSB_ERROR_DUPLICATEMEMBER',	"選手名が重複しています");
define('_MD_BBSB_ERROR_DUPLICATEUNO',		"背番号が重複しています");
define('_MD_BBSB_ERROR_FILENOTFOUND',		"ファイルがありません");
define('_MD_BBSB_ERROR_DIRNOTFOUND',		"ディレクトリがありません");
define('_MD_BBSB_ERROR_URLNOTFOUND',		"URLまたはパスワードが不正です");
define('_MD_BBSB_ERROR_FILEREADERROR',		"ファイルの読み込みに失敗しました");
define('_MD_BBSB_ERROR_CONVERTERROR',		"データ移行でエラーが発生しました。中断します。");
define('_MD_BBSB_ERROR_BLANKNAME',			"氏名かニックネームのいずれかは必ず入力してください。");
define('_MD_BBSB_ERROR_FILE_EXTENSION', 	"アップロードされたファイルは許可された拡張子と一致しません");
define('_MD_BBSB_ERROR_MAXFILESIZE',		"ファイルサイズが大きすぎます");
define('_MD_BBSB_ERROR_PUTFILE',			"ファイル保存に失敗しました。{0}に書き込み権限がついていることを確認してください。");
define('_MD_BBSB_ERROR_EMAILREQUIRED',		"「{0}」を選択しているので、Emailは必須入力項目です。");
define('_MD_BBSB_ERROR_UNONOTFOUND',		"背番号{0}のメンバーは存在しません");
define('_MD_BBSB_ERROR_NOENTRANT',			"参加者が登録されていません。「打順・参加選手登録」で参加者を登録してください。");

// CAUTION
define('_MD_BBSB_CAUTION_NORECORD',			"対象レコードがありません");
define('_MD_BBSB_CAUTION_INVALIDPASS',		"ユーザーまたはパスワードが不正です");

// INFO
define('_MD_BBSB_INFO_ALREADYEXISTS',		"データが既に存在します。スキップします");
define('_MD_BBSB_INFO_IMPORTSUCCESS',		"インポート成功");
define('_MD_BBSB_INFO_DELCONFIRM',			"このデータを削除します。よろしいですか？");
define('_MD_BBSB_INFO_DELOK',				"削除しました");
define('_MD_BBSB_INFO_NESESSARY',			"は必須項目です");
define('_MD_BBSB_INFO_IMGFILE',				"画像は100px×100pxの大きさで表示されます。ただし縮小変換は行いません。");
define('_MD_BBSB_INFO_DELCOMFIRM',			"本当に削除しますか？");
define('_MD_BBSB_INFO_BATSCOREINFO1',		"※打順も選手名も入力していない場合は登録されません。（削除されます。）");
define('_MD_BBSB_INFO_BATSCOREINFO2',		"※1試合で同一選手を2回以上入力する事は出来ません");
define('_MD_BBSB_INFO_NEWENTRYNOTICE',		"(新規入力時のみ必須)");
define('_MD_BBSB_INFO_EDITENTRY',			"投稿内容の編集：");
define('_MD_BBSB_INFO_MEMBEPRIVACY',		"電話番号などの個人情報は、管理権限のあるユーザー以外は閲覧できません。");
define('_MD_BBSB_INFO_EDITENTRANT',			"※打席ごとの打撃成績を登録するには、先に打順・参加選手登録が必要です。");						// Mobile
define('_MD_BBSB_INFO_EDITPERSONAL',		"※まずこの画面で試合データを作成・登録してください。打撃成績や投手成績は、その後でないと作成できません。");	//Mobile
define('_MD_BBSB_INFO_SB_NOTICE',			"※「盗塁」「盗失」「得点」は打席ごとの値ではなく1試合通しての合計値を入力してください。");				// Mobile
define('_MD_BBSB_INFO_SCORE_NOTICE',		"メンバーを削除すると打席ごとの打撃成績も消去されますので注意してください。");						// Mobile

// MAIL
define('_MD_BBSB_LANG_SCHEENTRYSUBJECT',	"[活動予定]%s:%s:%sに出欠登録がありました");

// 活動予定
define('_MD_BBSB_LANG_SCHEDULEID',			"スケジュールID");
define('_MD_BBSB_LANG_EVENTKIND',			"イベント種類");
define('_MD_BBSB_LANG_EVENTNAME',			"イベント名称");
define('_MD_BBSB_LANG_SUBMITTER',			"投稿者");
define('_MD_BBSB_LANG_EMAIL',				"Email");
define('_MD_BBSB_LANG_MOREEMAIL',			"コンマで区切りで複数指定可");
define('_MD_BBSB_LANG_DISPEMAILFLG',		"Email公開");
define('_MD_BBSB_LANG_DISPEMAILYES',		"公開する");
define('_MD_BBSB_LANG_DISPEMAILNO',			"公開しない");
define('_MD_BBSB_LANG_NOTICEEMAILFLG',		"参加状況が更新された場合");
define('_MD_BBSB_LANG_NOTICEEMAILYES',		"更新通知をEmailで受け取る");
define('_MD_BBSB_LANG_NOTICEEMAILNO',		"受け取らない");
define('_MD_BBSB_LANG_MAPDISP',				"登録した埋め込みマップを表示する");

define('_MD_BBSB_LANG_PRACTICE',			"練習");
define('_MD_BBSB_LANG_SETC',				"その他");
define('_MD_BBSB_LANG_JOINSTATE_YES',		"参加");
define('_MD_BBSB_LANG_JOINSTATE_NO',		"不参加");
define('_MD_BBSB_LANG_JOINSTATE_UNKNOWN',	"未定");
define('_MD_BBSB_LANG_REGARDAS',			"扱い");
define('_MD_BBSB_LANG_JOINSTATE_S',			"出欠");
define('_MD_BBSB_LANG_JOINSUMMARY',			"出欠サマリ");
define('_MD_BBSB_LANG_JOINDETAIL',			"出欠状況");
define('_MD_BBSB_LANG_PERSON',				"人");
define('_MD_BBSB_LANG_SCHENEWENTRY',		"出欠の新規登録");
define('_MD_BBSB_LANG_NAME',				"名前");
define('_MD_BBSB_LANG_PASSWORD',			"パスワード");

define('_MD_BBSB_LANG_SCOREBOOKPATH',		"スコアブックディレクトリへのパス");

define('_MD_BBSB_LANG_EVENTYEAR',			"年");
define('_MD_BBSB_LANG_EVENTMONTH',			"月");
define('_MD_BBSB_LANG_EVENTDAY',			"日");
define('_MD_BBSB_LANG_EVENTHOUR',			"時");
define('_MD_BBSB_LANG_EVENTMINUTE',			"分");
define('_MD_BBSB_LANG_DATE',				"日付");
define('_MD_BBSB_LANG_SUN',					"日");
define('_MD_BBSB_LANG_MON',					"月");
define('_MD_BBSB_LANG_TUE',					"火");
define('_MD_BBSB_LANG_WED',					"水");
define('_MD_BBSB_LANG_THU',					"木");
define('_MD_BBSB_LANG_FRI',					"金");
define('_MD_BBSB_LANG_SAT',					"土");

define('_MD_BBSB_LANG_OPPONENT',			"対戦相手");
define('_MD_BBSB_LANG_ANNOUNCEMSG',			"案内文");
define('_MD_BBSB_LANG_JOINSTATE',			"出欠選択肢");

// 対戦相手
define('_MD_BBSB_LANG_TEAMID',				"チームID");
define('_MD_BBSB_LANG_TEAMNAME',			"チーム名");
define('_MD_BBSB_LANG_BASEPLACE',			"拠点");
define('_MD_BBSB_LANG_LASTGAMEDATE',		"最終対戦日");
define('_MD_BBSB_LANG_OP_REP',				"代表者氏名");
define('_MD_BBSB_LANG_FULLNAME',			"氏名");
define('_MD_BBSB_LANG_PHONENUMBER',			"電話番号");
define('_MD_BBSB_LANG_MOBILEPHONE',			"携帯電話番号");
define('_MD_BBSB_LANG_MOBILEEMAIL',			"携帯 Email");
define('_MD_BBSB_LANG_PCEMAIL',				"PC Email");
define('_MD_BBSB_LANG_COMMENT',				"コメント");
define('_MD_BBSB_LANG_URL',					"URL");

// 画面機能
define('_MD_BBSB_LANG_NEWENTRY',			"新規登録");
define('_MD_BBSB_LANG_LASTUPDATE',			"最終更新日");
define('_MD_BBSB_LANG_SEARCH',				"検索");
define('_MD_BBSB_LANG_DETAIL',				"詳細");
define('_MD_BBSB_LANG_EDIT',				"編集");
define('_MD_BBSB_LANG_DELETE',				"削除");
define('_MD_BBSB_LANG_ENTRY',				"登録");
define('_MD_BBSB_LANG_BACK',				"戻る");
define('_MD_BBSB_LANG_UPDATE',				"修正");
define('_MD_BBSB_LANG_SINGLEBYTE',			"(半角で)");

// 試合、バッター
define('_MD_BBSB_LANG_GAMEID',				"試合ID");
define('_MD_BBSB_LANG_GAME',				"試合");
define('_MD_BBSB_LANG_EVENTNENDO',			"年度");
define('_MD_BBSB_LANG_EVENTDATE',			"日付");
define('_MD_BBSB_LANG_GAMES',				"試合順");
define('_MD_BBSB_LANG_GAMESEQ',				"試合目");
define('_MD_BBSB_LANG_LEAGUE',				"主催/リーグ");
define('_MD_BBSB_LANG_TOURNAMENT',			"大会/トーナメント");
define('_MD_BBSB_LANG_GAMEORDER',			"回戦");
define('_MD_BBSB_LANG_SCORE',				"スコア");
define('_MD_BBSB_LANG_FIRSTTEAMPOINT',		"先攻チーム得点");
define('_MD_BBSB_LANG_LASTTEAMPOINT',		"後攻チーム得点");
define('_MD_BBSB_LANG_RESULT',				"勝敗");
define('_MD_BBSB_LANG_RESULT_NOTICE',		"通常は「上記スコア通り」を指定して下さい");
define('_MD_BBSB_LANG_BATTERY',				"バッテリー");
define('_MD_BBSB_LANG_FIRSTBATTERY',		"先攻バッテリー");
define('_MD_BBSB_LANG_LASTBATTERY',			"後攻バッテリー");
define('_MD_BBSB_LANG_LONGHITS',			"長打");
define('_MD_BBSB_LANG_HITSCNT',				"安打数：");
define('_MD_BBSB_LANG_HITSCNTUNIT',			"本");
define('_MD_BBSB_LANG_LONGHITS_2H',			"二塁打：");
define('_MD_BBSB_LANG_LONGHITS_3H',			"三塁打：");
define('_MD_BBSB_LANG_LONGHITS_HR',			"ホームラン：");
define('_MD_BBSB_LANG_GAMECOMMENT',			"内容");
define('_MD_BBSB_LANG_INNINGHEADER',		"打撃成績のイニング");
define('_MD_BBSB_LANG_PLAYORDER',			"打順");
define('_MD_BBSB_LANG_CHANGECNT',			"先発");
define('_MD_BBSB_LANG_CHANGECNTCHG',		"交代");
define('_MD_BBSB_LANG_PLAYMEMBER',			"選手名");
define('_MD_BBSB_LANG_POSITION',			"守備");
define('_MD_BBSB_LANG_POSITION_V',			"守<BR>備<BR>");
define('_MD_BBSB_LANG_STOLENBASESUC',		"盗<BR>塁<BR>");
define('_MD_BBSB_LANG_STOLENBASEFAIL',		"盗<BR>失<BR>");
define('_MD_BBSB_LANG_RUNSCNT',				"得点");
define('_MD_BBSB_LANG_RUNSCNT_V',			"得<BR>点<BR>");
define('_MD_BBSB_LANG_ERRORSCNT',			"失策");
define('_MD_BBSB_LANG_ERRORSCNT_V',			"失<BR>策<BR>");
define('_MD_BBSB_LANG_WINNINGRUN_V',		"勝<BR>利<BR>打<BR>点<BR>");
define('_MD_BBSB_LANG_WINNINGRUN_S',		"勝打");
define('_MD_BBSB_LANG_SCOREMARK',			"打撃結果");
define('_MD_BBSB_LANG_DIRECTION',			"打球方向");
define('_MD_BBSB_LANG_RBI',					"打<BR>点<BR>");

// ピッチャー
define('_MD_BBSB_LANG_PITCHERNAME',			"投手名");
define('_MD_BBSB_LANG_PITCHINNING',			"投手成績：イニング数");
define('_MD_BBSB_LANG_PITCH_EARNEDRUNS',	"自責点");
define('_MD_BBSB_LANG_PITCH_RUNS',			"失点");
define('_MD_BBSB_LANG_PITCH_KCNT',			"奪三振");
define('_MD_BBSB_LANG_PITCH_BCNT',			"与四球");
define('_MD_BBSB_LANG_PITCH_DBCNT',			"与死球");
define('_MD_BBSB_LANG_PITCH_HCNT',			"被安打");
define('_MD_BBSB_LANG_PITCH_HRCNT',			"被本塁打");
define('_MD_BBSB_LANG_PITCH_NUMOFPITCH',	"投球数");
define('_MD_BBSB_LANG_WINLOSE',				"勝敗");
define('_MD_BBSB_LANG_KOHAKUSEN',			"紅白戦");
define('_MD_BBSB_LANG_WIN',					"勝");
define('_MD_BBSB_LANG_LOSE',				"敗");
define('_MD_BBSB_LANG_LOSE2',				"負");
define('_MD_BBSB_LANG_EVEN',				"分");
define('_MD_BBSB_LANG_SAVE',				"セーブ");
define('_MD_BBSB_LANG_HOLD',				"ホールド");

// 勝敗
define('_MD_BBSB_LANG_SCORERESULT',			"上記スコア通り");
define('_MD_BBSB_LANG_LOTWIN',				"抽選勝ち");
define('_MD_BBSB_LANG_DEFAULTWIN',			"不戦勝");
define('_MD_BBSB_LANG_ETCWIN',				"その他勝ち");
define('_MD_BBSB_LANG_LOTLOSE',				"抽選負け");
define('_MD_BBSB_LANG_DEFAULTLOSE',			"不戦敗");
define('_MD_BBSB_LANG_ETCLOSE',				"その他負け");
define('_MD_BBSB_LANG_GWIN',				"勝利");
define('_MD_BBSB_LANG_GLOSE',				"敗北");
define('_MD_BBSB_LANG_GEVEN',				"引分");
define('_MD_BBSB_LANG_GETC',				"その他");

// 守備
define('_MD_BBSB_LANG_PITCHER',				"投");
define('_MD_BBSB_LANG_CATCHER',				"捕");
define('_MD_BBSB_LANG_FIRST',				"一");
define('_MD_BBSB_LANG_SECOND',				"二");
define('_MD_BBSB_LANG_THIRD',				"三");
define('_MD_BBSB_LANG_SHORT',				"遊");
define('_MD_BBSB_LANG_LEFT',				"左");
define('_MD_BBSB_LANG_CENTER',				"中");
define('_MD_BBSB_LANG_RIGHT',				"右");
define('_MD_BBSB_LANG_BLANK',				"　");

// 選手成績
define('_MD_BBSB_LANG_SCORETABLE',			"成績表");
define('_MD_BBSB_LANG_SCOREBGRAPH',			"打率グラフ");
define('_MD_BBSB_LANG_SCOREPGRAPH',			"防御率グラフ");
define('_MD_BBSB_LANG_SEARCHGAMES',			"対象試合数");
define('_MD_BBSB_LANG_BATSCORE',			"打撃成績");
define('_MD_BBSB_LANG_BATREGULATION',		"規定打席数は");
define('_MD_BBSB_LANG_PITCHSCORE',			"投手成績");
define('_MD_BBSB_LANG_PITCHREGULATION',		"規定投球回数は");
define('_MD_BBSB_LANG_RANK',				"順<BR>位<BR>");
define('_MD_BBSB_LANG_NO',					"背<BR>番<BR>号<BR>");
define('_MD_BBSB_LANG_AVG',					"打<BR>率<BR>");
define('_MD_BBSB_LANG_2BASE',				"二<BR>塁<BR>打<BR>");
define('_MD_BBSB_LANG_3BASE',				"三<BR>塁<BR>打<BR>");
define('_MD_BBSB_LANG_HR',					"本<BR>塁<BR>打<BR>");
define('_MD_BBSB_LANG_TB',					"塁<BR>打<BR>数<BR>");
define('_MD_BBSB_LANG_GAMETOTAL',			"試<BR>合<BR>数<BR>");
define('_MD_BBSB_LANG_TPA',					"打<BR>席<BR>");
define('_MD_BBSB_LANG_ATBATS',				"打<BR>数<BR>");
define('_MD_BBSB_LANG_HITS',				"安<BR>打<BR>");
define('_MD_BBSB_LANG_SBP',					"成<BR>功<BR>率<BR>");
define('_MD_BBSB_LANG_B',					"四<BR>球<BR>");
define('_MD_BBSB_LANG_D',					"死<BR>球<BR>");
define('_MD_BBSB_LANG_K',					"三<BR>振<BR>");
define('_MD_BBSB_LANG_GF',					"犠<BR>飛<BR>");
define('_MD_BBSB_LANG_FC',					"野<BR>選<BR>");
define('_MD_BBSB_LANG_W',					"併<BR>殺<BR>");
define('_MD_BBSB_LANG_OE',					"敵<BR>失<BR>");
define('_MD_BBSB_LANG_OG',					"ア<BR>(ゴ)<BR>");
define('_MD_BBSB_LANG_OF',					"ア<BR>(飛)<BR>");
define('_MD_BBSB_LANG_OL',					"ア<BR>(直)<BR>");
define('_MD_BBSB_LANG_OJ',					"ア<BR>(邪)<BR>");
define('_MD_BBSB_LANG_OBP',					"出<BR>塁<BR>率<BR>");
define('_MD_BBSB_LANG_SLG',					"長<BR>打<BR>率<BR>");
define('_MD_BBSB_LANG_TEAMSCORE',			"チーム成績");
define('_MD_BBSB_LANG_PRANK',				"順位");
define('_MD_BBSB_LANG_PGAMES',				"試合数");
define('_MD_BBSB_LANG_PINNING',				"投球回数");
define('_MD_BBSB_LANG_ERA',					"防御率");
define('_MD_BBSB_LANG_PINNINGUNIT',			"回");

// メンバー
define('_MD_BBSB_LANG_PLAYER',				"選手");
define('_MD_BBSB_LANG_SHOWORDER',			"表示順");
define('_MD_BBSB_LANG_MANAGEINFO',			"管理情報");
define('_MD_BBSB_LANG_UNIFORMNO',			"背番号");
define('_MD_BBSB_LANG_SORTMSG',				"でソート");
define('_MD_BBSB_LANG_USERID',				"ユーザID");
define('_MD_BBSB_LANG_NICKNAME',			"ニックネーム");
define('_MD_BBSB_LANG_POST',				"役職");
define('_MD_BBSB_LANG_PANDB',				"投打");
define('_MD_BBSB_LANG_PANDBMSG',			"「右投げ右打ち」など");
define('_MD_BBSB_LANG_BIRTHDAY',			"生年月日");
define('_MD_BBSB_LANG_PROFILE',				"プロフィール");
define('_MD_BBSB_LANG_ZIPCODE',				"郵便番号");
define('_MD_BBSB_LANG_ADRESS',				"住所");
define('_MD_BBSB_LANG_SCOREENTERY',			"個人成績に含める");
define('_MD_BBSB_LANG_PROFILEENTERY',		"プロフィール公開");
define('_MD_BBSB_LANG_IMG_FILE',			"画像ファイル");

// 球場
define('_MD_BBSB_LANG_GROUNDID',			"グラウンドID");
define('_MD_BBSB_LANG_GROUND',				"グラウンド");
define('_MD_BBSB_LANG_CODEFIELD',			"マップ<BR>(GoogleやYahooの地図を埋め込むことができます)");

// リーグ
define('_MD_BBSB_LANG_LEAGUEID',			"リーグID");
define('_MD_BBSB_LANG_SYNCURL',				"試合データ同期用URL");

// トーナメント、回戦
define('_MD_BBSB_LANG_TOURNAMENTID',		"トーナメントID");
define('_MD_BBSB_LANG_GAMEORDERID',			"回戦ID");


// DBにデフォルト値を登録するための定義

define('_MD_BBSB_LANG_DB_JOIN',				"参加します");
define('_MD_BBSB_LANG_DB_GAME',				"試合なら調整します");
define('_MD_BBSB_LANG_DB_NOTJOIN',			"不参加です");
define('_MD_BBSB_LANG_DB_UNKNOWN',			"未定");

define('_MD_BBSB_LANG_DB_KAISEN',			"回戦");
define('_MD_BBSB_LANG_DB_JUNJUN',			"準々決勝戦");
define('_MD_BBSB_LANG_DB_JUN',				"準決勝戦");
define('_MD_BBSB_LANG_DB_FINAL',			"決勝戦");
define('_MD_BBSB_LANG_DB_SETSU',			"第%s節");

define('_MD_BBSB_LANG_DB_OG',				"ゴロ");
define('_MD_BBSB_LANG_DB_OF',				"飛");
define('_MD_BBSB_LANG_DB_H',				"単打");
define('_MD_BBSB_LANG_DB_B',				"四球");
define('_MD_BBSB_LANG_DB_D',				"死球");
define('_MD_BBSB_LANG_DB_BH',				"内安");
define('_MD_BBSB_LANG_DB_2H',				"二塁");
define('_MD_BBSB_LANG_DB_3H',				"三塁");
define('_MD_BBSB_LANG_DB_HR',				"HR");
define('_MD_BBSB_LANG_DB_G',				"犠打");
define('_MD_BBSB_LANG_DB_GF',				"犠飛");
define('_MD_BBSB_LANG_DB_S',				"進打");
define('_MD_BBSB_LANG_DB_FC',				"野選");
define('_MD_BBSB_LANG_DB_E',				"敵失");
define('_MD_BBSB_LANG_DB_IF',				"妨害");
define('_MD_BBSB_LANG_DB_K',				"三振");
define('_MD_BBSB_LANG_DB_KE',				"振逃");
define('_MD_BBSB_LANG_DB_O',				"OUT");
define('_MD_BBSB_LANG_DB_OL',				"直");
define('_MD_BBSB_LANG_DB_OJ',				"邪飛");
define('_MD_BBSB_LANG_DB_W',				"併殺");

define('_MD_BBSB_LANG_DB_S_OG',				"ゴ");
define('_MD_BBSB_LANG_DB_S_OF',				"飛");
define('_MD_BBSB_LANG_DB_S_H',				"安");
define('_MD_BBSB_LANG_DB_S_B',				"四");
define('_MD_BBSB_LANG_DB_S_D',				"死");
define('_MD_BBSB_LANG_DB_S_BH',				"内");
define('_MD_BBSB_LANG_DB_S_2H',				"二");
define('_MD_BBSB_LANG_DB_S_3H',				"三");
define('_MD_BBSB_LANG_DB_S_HR',				"HR");
define('_MD_BBSB_LANG_DB_S_G',				"犠");
define('_MD_BBSB_LANG_DB_S_GF',				"犠");
define('_MD_BBSB_LANG_DB_S_S',				"進");
define('_MD_BBSB_LANG_DB_S_FC',				"野");
define('_MD_BBSB_LANG_DB_S_E',				"失");
define('_MD_BBSB_LANG_DB_S_IF',				"妨");
define('_MD_BBSB_LANG_DB_S_K',				"Ｋ");
define('_MD_BBSB_LANG_DB_S_KE',				"逃");
define('_MD_BBSB_LANG_DB_S_O',				"ア");
define('_MD_BBSB_LANG_DB_S_OL',				"直");
define('_MD_BBSB_LANG_DB_S_OJ',				"邪");
define('_MD_BBSB_LANG_DB_S_W',				"併");

// 「行くぜ」からの移行用
define('_MD_BBSB_LANG_IKZ_MEMBER',			"選手");
define('_MD_BBSB_LANG_IKZ_LEAGUE',			"主催");
define('_MD_BBSB_LANG_IKZ_TOURNAMENT',		"大会");
define('_MD_BBSB_LANG_IKZ_GAMEORDER',		"回戦");
define('_MD_BBSB_LANG_IKZ_GROUND',			"場所");
define('_MD_BBSB_LANG_IKZ_KIHON',			"基本・デザイン");
define('_MD_BBSB_LANG_IKZ_MENU',			"成績管理");
define('_MD_BBSB_LANG_IKZ_MODIFY',			"修正");



?>