<?php
// Module Info

// The name of this module
define("_MI_BBSB_NAME",								"WebScoreRevolution");
define("_MI_BBSB_NAVINAME",							"WebScore");		// ナビゲーション用

// A brief description of this module
define("_MI_BBSB_DESC",								"野球スコアブック管理モジュール");

// Admin Menu
define("_MI_BBSB_ADMENU_SWITCHOVER",				"データ移行ツール");

// Sub menu titles
define("_MI_BBSB_MENU_SCHEDULE",					"活動予定");
define("_MI_BBSB_MENU_VIEWGAMELIST",				"対戦成績");
define("_MI_BBSB_MENU_VIEWMEMBERLIST",				"選手紹介");
define("_MI_BBSB_MENU_VIEWPERSONALSCORE",			"個人成績");
define("_MI_BBSB_MENU_OPPONENT",					"対戦相手管理");
define("_MI_BBSB_MENU_GROUND",						"グラウンド管理");
define("_MI_BBSB_MENU_LEAGUE",						"主催・リーグ管理");
define("_MI_BBSB_MENU_TOURNAMENT",					"大会・回戦管理");

define("_MI_BBSB_MENU_VIEWSCHEDULEDETAIL",			"活動予定詳細");
define("_MI_BBSB_MENU_EDITSCHEDULEDETAIL",			"活動予定登録");
define("_MI_BBSB_MENU_EDITSCHEDULEMEMBERDETAIL",	"出欠登録");
define("_MI_BBSB_MENU_VIEWGAMEDETAIL",				"対戦結果詳細");
define("_MI_BBSB_MENU_EDITGAMEDETAIL",				"対戦結果登録");
define("_MI_BBSB_MENU_EDITMEMBERDETAIL",			"選手情報登録");
define("_MI_BBSB_MENU_VIEWOPPONENTDETAIL",			"対戦相手情報詳細");
define("_MI_BBSB_MENU_EDITOPPONENTDETAIL",			"対戦相手情報登録");
define("_MI_BBSB_MENU_VIEWGROUNDDETAIL",			"グラウンド情報詳細");
define("_MI_BBSB_MENU_EDITGROUNDDETAIL",			"グラウンド情報登録");
define("_MI_BBSB_MENU_EDITLEAGUEDETAIL",			"主催・リーグ情報登録");
define("_MI_BBSB_MENU_EDITTOURNAMENTDETAIL",		"大会・トーナメント情報登録");
define("_MI_BBSB_MENU_EDITGAMEORDERDETAIL",			"回戦情報登録");

define("_MI_BBSB_MENU_EDITGAMEDETAILMENT",			"打順・参加選手登録");
define("_MI_BBSB_MENU_EDITGAMEDETAILMINN",			"打撃成績登録");
define("_MI_BBSB_MENU_EDITGAMEDETAILMPIT",			"投手成績登録");

// Config
define("_MI_BBSB_CFG_INNINGS_T",		"1試合あたりのイニング数");
define("_MI_BBSB_CFG_INNINGS_D",		"草野球なら7、一般の野球なら9にしてください。主に防御率計算用。");

define("_MI_BBSB_CFG_ENTRYINNINGS_T",	"登録/更新可能な最大イニング");
define("_MI_BBSB_CFG_ENTRYINNINGS_D",	"あまり大きな値にするとレイアウトが崩れるので12を推奨します。この値より大きいイニングは登録できません。");

define("_MI_BBSB_CFG_DISPINNINGS_T",	"表示用イニング数");
define("_MI_BBSB_CFG_DISPINNINGS_D",	"対戦成績一覧画面などで、表示用レイアウトをカスタマイズしたいときに調節してください。");

define("_MI_BBSB_CFG_STARTYEAR_T",		"チーム設立年(西暦)");
define("_MI_BBSB_CFG_STARTYEAR_D",		"この年以降が対戦結果が入力可能な範囲になります");

define("_MI_BBSB_CFG_OWNTEAMNAME_T",	"自チーム名称");
define("_MI_BBSB_CFG_OWNTEAMNAME_V",	"自チーム");


define("_MI_BBSB_CFG_REGURATION_T",		"規定打席数");
define("_MI_BBSB_CFG_REGURATION_D",		"1試合あたりの規定打席を入力してください");

define("_MI_BBSB_CFG_PREGURATION_T",	"規定投球回数");
define("_MI_BBSB_CFG_PREGURATION_D",	"1試合あたりの規定投球回数を入力してください");

define("_MI_BBSB_CFG_NAMEDISP_T",		"氏名表示に本名を使用する");
define("_MI_BBSB_CFG_NAMEDISP_D",		"「いいえ」にした場合はニックネームを使用します。ただしニックネームが登録されている時のみ。");

define("_MI_BBSB_CFG_DISPSCORE_T",		"個人成績を公開する");
define("_MI_BBSB_CFG_DISPSCORE_D",		"「いいえ」にした場合は個人成績一覧画面と、試合詳細の打撃成績/投手成績ををゲスト公開しません。ログインが必要となります、");

define("_MI_BBSB_CFG_DISPSCHE_T",		"「活動予定」機能を使用する");
define("_MI_BBSB_CFG_DISPSCHE_D",		"「いいえ」にした場合は活動予定機能をメニューから外します");

// Blocks
define("_MI_BBSB_BLOCK_RECENT_SCHE_T",	"チームの活動予定");
define("_MI_BBSB_BLOCK_RECENT_SCHE_D",	"試合、練習などの活動予定を表示します。");

define("_MI_BBSB_BLOCK_RECENT_GAME_T",	"最近の試合");
define("_MI_BBSB_BLOCK_RECENT_GAME_D",	"最近に行われた試合の概要をを表示します。");

?>